<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>

<style type="text/css">
<!--
body { font-family: Arial, Helvetica, sans-serif; font-size: 9pt }
td {  font-family: Arial, Helvetica, sans-serif; font-size: 9pt}
th {  font-family: Arial, Helvetica, sans-serif; font-size: 9pt; font-weight: bold}
-->
</style>
<%@ page language="java" 
    import="org.halfcat.halflife.*, 
	    org.halfcat.halflife.cstrike.*, 
	    org.halfcat.persistence.*,
	    java.util.*, 
	    java.text.*, 
	    java.net.*" 
%>
<jsp:useBean id="rconServers" scope="session" class="java.util.Hashtable" />
<jsp:useBean id="statusServers" scope="session" class="java.util.Hashtable" />

<%
  SimpleDateFormat sdf = new SimpleDateFormat( "dd MMMM yyyy hh:mm:ss aa zzz" );
  DecimalFormat df = new java.text.DecimalFormat( "##0.00" );
  Game g = null;
  String gameId = request.getParameter( "gameId" );
  System.out.println( "Profile of game " + gameId );
  if ( gameId != null )
    g = GameSource.getGame( Integer.parseInt( gameId ) );

  if ( g == null )
  {
%>
<title>Invalid request</title>
</head>
<body>
<b>There is currently no game in the database with this ID</b>
</body>
</html>
<%
    return;
  }

  long wonId = -1;
  String wonIdStr = request.getParameter( "wonId" );
  if ( wonIdStr != null )
  {
    try
    {
      wonId = Long.parseLong( wonIdStr );
      System.out.println( "Starring " + wonIdStr );
    }
    catch( Exception ee )
    {
      System.out.println( "invalid: " + wonIdStr );
    }
  }

  boolean listAlias = false;
  int colSpan = 10;
%>
<title>Summary of <%= g.getMapName() %> at <%= g.getStartTime() %></title>
<body>
<table border="1">
<tr>
<td colspan="<%= colSpan + 1 %>">

<table width="100%">
<tr>
<th width="100%" colspan="4">
	Summary of <%= g.getMapName() %> at <%= sdf.format( g.getStartTime() ) %>
</th>
</tr>
<tr>
  <td width="1%" nowrap><b>Map:</b></td>
  <td colspan="4"><%= g.getMapName() %></td>
</tr>
<tr>
  <td width="1%" nowrap><b>Start:</b></td>
  <td colspan="4"><%= sdf.format( g.getStartTime() ) %></td>
</tr>
<tr>
  <td width="1%" nowrap><b>End:</b></td>
  <td colspan="4"><%= sdf.format( g.getEndTime() ) %></td>
</tr>
<tr>
  <td><b>Score</b>:</td>
  <td>CounterTerrorists: <b><%= g.getCtWins() %></td>
  <td>Terrorists: <b><%= g.getTerrWins() %></td>
  <td>Draws: <b><%= g.getDraws() %></td>
</tr>
</table>

<%
// hostage kills are not logged for now

// get all kill/death info
// do this in code until the query stuff is sorted
int kills = 0;
int deaths = 0;
int ht = 0;
int hr = 0;
//int hk = 0;
int tk = 0;
int bp = 0;
int bd = 0;
int recon = 0;
GamePlayer pg;
Collection scores = g.getGamePlayers().values();
Iterator ii = scores.iterator();
while ( ii.hasNext() )
{
  pg = (GamePlayer)ii.next();

  kills += pg.getKills();
  deaths += pg.getDeaths();

  ht += pg.getTouchedHostages();
  hr += pg.getRescuedHostages();
//  hk += pg.getKilledHostages();

  bp += pg.getBombPlants();
  bd += pg.getBombDefuses();

  tk += pg.getTks();  
  recon += pg.getReconnects();
}
float killRatio =(float)0.0;
%>
</td>
</tr>

<tr>
<th valign="bottom">Player</th>
<th valign="bottom">Kills</th>
<th valign="bottom">Deaths</th>
<th nowrap valign="bottom">Kill Ratio</th>
<th valign="bottom">TK's</th>
<th>Hostages<br>Touched</th>
<th>Hostages<br>Rescued</th>
<th>Bomb<br>Plants</th>
<th>Bomb<br>Defuses</th>
<th valign="bottom">Reconnects</th>
</tr>
<%
Iterator iii = scores.iterator();
String bStart, bEnd;
while ( iii.hasNext() )
{
  pg = (GamePlayer)iii.next();
  if ( pg.getWonID() == wonId )
  {
    bStart="<b>";
    bEnd = "</b>";
  }
  else
  {
    bStart="";
    bEnd = "";
  }
%>
  <td><%= bStart %>
    <a href="playerProfile.jsp?wonId=<%= pg.getWonID() %>"><%= pg.getCurrentName() %></a>
    <%= bEnd %>
  </td>
  <td align="right">
    <%= bStart %><%= pg.getKills() %><%= bEnd %></td>
  <td align="right">
    <%= bStart %><%= pg.getDeaths() %><%= bEnd %></td>
  <td align="right">
    <%= bStart %><%= (pg.getDeaths() == 0 ) ? new String( "" + pg.getKills() ) : df.format( (float)pg.getKills() / (float)pg.getDeaths() ) %>
<%= bEnd %></td>
  <td align="right">
    <%= bStart %><%= pg.getTks() %><%= bEnd %></td>
  <td align="right">
    <%= bStart %><%= pg.getTouchedHostages() %><%= bEnd %></td>
  <td align="right">
    <%= bStart %><%= pg.getRescuedHostages() %><%= bEnd %></td>
  <td align="right">
    <%= bStart %><%= pg.getBombPlants() %><%= bEnd %></td>
  <td align="right">
    <%= bStart %><%= pg.getBombDefuses() %><%= bEnd %></td>
  <td align="right">
    <%= bStart %><%= pg.getReconnects() %><%= bEnd %></td>
</tr>
<%
}
%>
<tr>
  <tr>
    <td><b>Total</b></td>
    <td align="right"><b><%= kills %></b></td>
    <td align="right"><b><%= deaths %></b></td>
    <td align="right"><b><%= df.format( killRatio ) %></b></td>
    <td align="right"><b><%= tk %></b></td>
    <td align="right"><b><%= ht %></b></td>
    <td align="right"><b><%= hr %></b></td>
    <td align="right"><b><%= bp %></b></td>
    <td align="right"><b><%= bd %></b></td>
    <td align="right"><b><%= recon  %></b></td>
  </tr>
</tr>
</table>

