<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>

<style type="text/css">
<!--
body { font-family: Arial, Helvetica, sans-serif; font-size: 9pt }
td {  font-family: Arial, Helvetica, sans-serif; font-size: 9pt}
th {  font-family: Arial, Helvetica, sans-serif; font-size: 9pt; font-weight: bold}
-->
</style>
<%@ page language="java" 
    import="org.halfcat.halflife.*, 
	    org.halfcat.halflife.cstrike.*, 
	    org.halfcat.halflife.info.*, 
	    org.halfcat.persistence.*,
	    java.util.*, 
	    java.text.*, 
	    java.net.*" 
%>
<jsp:useBean id="rconServers" scope="session" class="java.util.Hashtable" />
<jsp:useBean id="statusServers" scope="session" class="java.util.Hashtable" />

<%
  Game g = null;
  String gameId = request.getParameter( "gameId" );
  System.out.println( "Profile of game " + gameId );
  if ( gameId != null )
    g = GameSource.getGame( Integer.parseInt( gameId ) );

  if ( g == null )
  {
%>
<title>Invalid request</title>
</head>
<body>
<b>There is currently no game in the database with this ID</b>
</body>
</html>
<%
    return;
  }

  long wonId = -1;
  String wonIdStr = request.getParameter( "wonId" );
  if ( wonIdStr != null )
  {
    try
    {
      wonId = Long.parseLong( wonIdStr );
      System.out.println( "Starring " + wonIdStr );
    }
    catch( Exception ee )
    {
      System.out.println( "invalid: " + wonIdStr );
    }
  }

  boolean listAlias = false;
  int colSpan = 10;
%>
<title>Summary of <%= g.getMapName() %>, Starting <%= sdf.format( g.getStartTime() ) %></title>
<body>
<table border="1">
<tr>
<td colspan="<%= colSpan + 1 %>">

<table width="100%">
<tr>
<th width="100%" colspan="4">
	Summary of <%= g.getMapName() %> starting <%= sdf.format( g.getStartTime() ) %>
</th>
</tr>
<tr>
  <td width="1%" nowrap><b>Map:</b></td>
  <td colspan="4"><%= g.getMapName() %></td>
</tr>
<tr>
  <td width="1%" nowrap><b>Start:</b></td>
  <td colspan="4"><%= sdf.format( g.getStartTime() ) %></td>
</tr>
<tr>
  <td width="1%" nowrap><b>End:</b></td>
  <td colspan="4"><%= sdf.format( g.getEndTime() ) %></td>
</tr>
<tr>
  <td><b>Score</b>:</td>
  <td>CounterTerrorists: <b><%= g.getCtWins() %></td>
  <td>Terrorists: <b><%= g.getTerrWins() %></td>
  <td>Draws: <b><%= g.getDraws() %></td>
</tr>
</table>
</td>
</tr>

<tr>
<th valign="bottom">Player</th>
<th valign="bottom">Kills</th>
<th valign="bottom">Deaths</th>
<th nowrap valign="bottom">Kill Ratio</th>
<th valign="bottom">TK's</th>
<th>Hostages<br>Touched</th>
<th>Hostages<br>Rescued</th>
<th>Bomb<br>Plants</th>
<th>Bomb<br>Defuses</th>
<th>VIP<br>Kills</th>
<th valign="bottom">Reconnects</th>
</tr>

<%
GamePlayer pg;
List scores = g.getGamePlayers();
GamePlayerComparator gcp = new GamePlayerComparator();
Collections.sort( scores, gcp );

List ct = new ArrayList();
List t  = new ArrayList();
List unk = new ArrayList();

GamePlayer totalsGp = new GamePlayer(), 
           ctGp = new GamePlayer(), 
           tGp = new GamePlayer(),
           unkGp = new GamePlayer();
totalsGp.setCurrentName( "Totals:" );
ctGp.setCurrentName( "CounterTerrorist Totals:" );
tGp.setCurrentName( "Terrorist Totals:" );
unkGp.setCurrentName( "Unknown Totals:" );

Iterator ii = scores.iterator();
while ( ii.hasNext() )
{
  pg = (GamePlayer)ii.next();

  if ( pg.getCurrentTeam() == GamePlayer.COUNTERTERRORIST )
  {
    ct.add( pg );
    totalPlayer( ctGp, pg );
  }
  else if ( pg.getCurrentTeam() == GamePlayer.TERRORIST )
  {
    t.add( pg );
    totalPlayer( tGp, pg );
  }
  else
  {
    unk.add( pg );
    totalPlayer( unkGp, pg );
  }
  totalPlayer( totalsGp, pg );
}
%>

<%!
SimpleDateFormat sdf = new SimpleDateFormat( "EEEE, dd MMMM yyyy hh:mm:ss aa zzz" );
DecimalFormat df = new java.text.DecimalFormat( "##0.00" );

public GamePlayer totalPlayer( GamePlayer totals, GamePlayer pg )
{
  totals.setKills( totals.getKills() + pg.getKills() );
  totals.setDeaths( totals.getDeaths() + pg.getDeaths() );

  totals.setTouchedHostages( totals.getTouchedHostages() + pg.getTouchedHostages() );
  totals.setRescuedHostages( totals.getRescuedHostages() + pg.getRescuedHostages() );

  totals.setBombPlants( totals.getBombPlants() + pg.getBombPlants() );
  totals.setBombDefuses( totals.getBombDefuses() + pg.getBombDefuses() );

  totals.setTks( totals.getTks() + pg.getTks() );
  totals.setReconnects( totals.getReconnects() + pg.getReconnects() );

  totals.setVipKills( totals.getVipKills() + pg.getVipKills() );

  return totals;
}

private String printRow( GamePlayer pg, boolean bold )
{
  return printRow( pg, bold, false );
}

private String printRow( GamePlayer pg, boolean bold, boolean noLink )
{
  String bStart="<b>";
  String bEnd = "</b>";

  StringBuffer sb = new StringBuffer( "<td nowrap>" );

  if ( bold ) sb.append( bStart );
  if ( noLink )
    sb.append( pg.getCurrentName() );
  else
    sb.append("<a href=\"playerProfile.jsp?wonId=" + pg.getWonID() + "\">" + pg.getCurrentName()+ "</a>" );
  if ( bold ) sb.append( bEnd );

  sb.append( "</td>\n<td align=\"right\">" );
  if ( bold ) sb.append( bStart );
  sb.append( pg.getKills() );

  sb.append( "</td>\n<td align=\"right\">" );
  if ( bold ) sb.append( bStart );
  sb.append( "" + pg.getDeaths() );
  if ( bold ) sb.append( bEnd );

  sb.append( "</td>\n<td align=\"right\">" );

  if ( bold ) sb.append( bStart );
  sb.append( (pg.getDeaths() == 0 ) ? new String( "" + pg.getKills() + ".00" ) : df.format( (float)pg.getKills() / (float)pg.getDeaths() ) );
  if ( bold ) sb.append( bEnd );

  sb.append( "</td>\n<td align=\"right\">" );

  if ( bold ) sb.append( bStart );
  sb.append( "" + pg.getTks() );
  if ( bold ) sb.append( bEnd );

  sb.append( "</td>\n<td align=\"right\">" );

  if ( bold ) sb.append( bStart );
  sb.append( "" + pg.getTouchedHostages() );
  if ( bold ) sb.append( bEnd );

  sb.append( "</td>\n<td align=\"right\">" );

  if ( bold ) sb.append( bStart );
  sb.append( "" + pg.getRescuedHostages() );
  if ( bold ) sb.append( bEnd );

  sb.append( "</td>\n<td align=\"right\">" );

  if ( bold ) sb.append( bStart );
  sb.append( "" + pg.getBombPlants() );
  if ( bold ) sb.append( bEnd );

  sb.append( "</td>\n<td align=\"right\">" );

  if ( bold ) sb.append( bStart );
  sb.append( "" + pg.getBombDefuses() );
  if ( bold ) sb.append( bEnd );

  sb.append( "</td>\n<td align=\"right\">" );

  if ( bold ) sb.append( bStart );
  sb.append( "" + pg.getVipKills() );
  if ( bold ) sb.append( bEnd );

  sb.append( "</td>\n<td align=\"right\">" );

  if ( bold ) sb.append( bStart );
  sb.append( "" + pg.getReconnects() );
  if ( bold ) sb.append( bEnd );

  sb.append( "</td>\n</tr>\n" );

  return sb.toString();
}
%>

<%
GamePlayer gp1, gp2;
String head1Str, head2Str;
String bg1, bg2;
Iterator iii;
boolean ctFirst = ( g.getCtWins() >= g.getTerrWins() );
if ( ctFirst )
{
  ii = ct.iterator();
  //head1Str = "<font color=\"#FFFFFF\">CounterTerrorists:</font>";
  head1Str = "CounterTerrorists:";
  gp1 = ctGp;
  bg1 = "AAAAFF";

  iii = t.iterator();
  head2Str = "Terrorists:";
  gp2 = tGp;
  bg2= "FF4444";
}
else
{
  ii = t.iterator();
  head1Str = "Terrorists:";
  gp1 = tGp;
  bg1= "FF2222";

  iii = ct.iterator();
  //head2Str = "<font color=\"#FFFFFF\">CounterTerrorists:</font>";
  head2Str = "CounterTerrorists:";
  gp2 = ctGp;
  bg2 = "AAAAFF";
}
%>

<tr><td colspan=13 bgcolor="<%= bg1 %>"><b><%= head1Str %></b></td></tr>

<%
while ( ii.hasNext() ) {
  GamePlayer gp = (GamePlayer)ii.next();
  boolean starring = ( gp.getWonID() == wonId );
%>
  <tr <%= ( starring ?  "bgcolor=\"#BBBBBB\"" : "" ) %>>
<%= printRow( gp, starring ) %>
<%
}
%>
<tr bgcolor="<%= bg1 %>">
<%= printRow( gp1, true, true ) %>

<tr><td colspan=13>&nbsp;</td></tr>
<tr><td colspan=13 bgcolor="<%= bg2 %>"><b><%= head2Str %></b></td></tr>

<%
while ( iii.hasNext() ) {
  GamePlayer gp = (GamePlayer)iii.next();
  boolean starring = ( gp.getWonID() == wonId );
%>
  <tr <%= ( starring ?  "bgcolor=\"#BBBBBB\"" : "" ) %>>
  <%= printRow( gp, ( gp.getWonID() == wonId ) ) %>
<% } %>
<tr bgcolor="<%= bg2 %>">
<%= printRow( gp2, true, true ) %>

<tr><td colspan=13>&nbsp;</td></tr>
<%= printRow( totalsGp, true, true ) %>
</table>

