<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>

<style type="text/css">
<!--
body { font-family: Arial, Helvetica, sans-serif; font-size: 9pt }
td {  font-family: Arial, Helvetica, sans-serif; font-size: 9pt}
th {  font-family: Arial, Helvetica, sans-serif; font-size: 9pt; font-weight: bold}
-->
</style>
<%@ page language="java" 
    import="org.halfcat.halflife.*, java.util.*, java.net.*" 
%>
<jsp:useBean id="rconServers" scope="session" class="java.util.Hashtable" />
<jsp:useBean id="statusServers" scope="session" class="java.util.Hashtable" />

<%
  if ( session.isNew() )
  {
    Cookie[] ca = request.getCookies();
    CookieProcessor.buildServersFromCookies( ca, rconServers, statusServers );
  }

  // get the requested server
  RconServer server;
  String serverId = request.getParameter( "server" );
  if ( serverId == null )
  {
%>
<jsp:forward page="listPlayers.jsp" />
<%
    return;
  }
  else if ( rconServers.containsKey( serverId ) )
  {
    server = (RconServer)rconServers.get( serverId );
  }
  else
  {
%>
<h2>No such server</h2>
<%
    return;
  }

  //
  // Check if it's a level change
  //

  if ( request.getParameter( "Change" ) != null )
  {
    String newMap = request.getParameter( "mapName" );
    if ( newMap != null )
    {
      String changeCmd;
      if ( request.getParameter( "keepTeams" ) != null )
	changeCmd = " changelevel2 ";
      else
	changeCmd = " changelevel ";
      System.out.println( "Changing level to " + newMap );
      server.rconCommand( changeCmd + newMap );
    }
  }
  else if ( request.getParameter( "Execute" ) != null )
    server.rconCommand( request.getParameter( "rconCommand" ) ); 
  else
  {
    String[] kickIds = request.getParameterValues( "kick" );

    // calculate & execute bans
    String[] banIds  = request.getParameterValues( "ban" );
    if ( banIds != null )
    {
      for ( int x = 0; x < banIds.length; x++ )
      {
	boolean kick = false;
	String banTime = request.getParameter( banIds[x] );
	if ( banTime == null )
	  banTime = "0";
	System.out.print( "Ban: " + banIds[x] + " for " + banTime + " min" );

	// determine if we're going to kick, too
	// kind've ugly, but ok for the number of times it'll get iterated
	if ( kickIds != null )
	{
	  for ( int y = 0; y < kickIds.length; y++ )
	  {
	      if ( kick )
		break;
	      kick = kickIds[y].equals( banIds[x] );
	    if ( kick )
	      kickIds[y] = null;
	  }
	}
	if ( kick )
	    System.out.println( " and kick!" );
	else
	    System.out.println( "." );

	server.ban( Long.parseLong( banIds[x] ), Integer.parseInt( banTime ), kick );
      }
    }

    // calculate & execute kicks
    if ( kickIds != null )
    {
      for ( int x = 0; x < kickIds.length; x++ )
      {
	if ( kickIds[x] == null )
	  continue;
	int sId = server.getServerId( Long.parseLong( kickIds[x] ) );
	System.out.println( "Kick: " + kickIds[x] + "->" + sId );
	server.kick( sId );
      }
    }
  }
  
  boolean serverUp = true;

  try
  {
    server.setWaitInMillis( (long)2000 );
    server.refresh();
  }
  catch( SocketException se )
  {
    se.printStackTrace();
    serverUp = false;
%>
    <title>Server Unavailable</title>
    </head>

    <body>
    <center>
    The server at <b><%= server.getQueryAddress() %>:<%= server.getQueryPort() %></b> is currently Unavailable for management.<br>
<%
  }
  catch( BadPasswordException bpe )
  {
    serverUp = false;
    StatusServer ss = (StatusServer)statusServers.get( serverId );
%>
    <title>Bad Password</title>
    </head>

    <body>
    <center>
    You supplied an incorrect  rcon password for
    <b><%= ss.getServerName() %></b> at
    <b><%= server.getQueryAddress() %>:<%= server.getQueryPort() %></b><p>

    <a href="addServer.jsp?address=<%= server.getQueryAddress() %>&port=<%= server.getQueryPort() %>">Update Server Information</a><br>
<%
  }

  if ( serverUp )
  {
%>
<title>Status of <%= server.getServerName() %></title>
</head>

<body>

<center>
<form method="post" action="manage.jsp">
  <input type="hidden" name="server" value="<%= serverId %>">
<table border="1" width="100%">
<tr>
  <td colspan=10>
    <table width="100%">
      <tr>
	<td colspan="2"><b><%= server.getServerName() %></b></td>
	<td align="right">
	  <A href="consoleFrame.jsp?server=<%= serverId %>" target="console-<%= serverId %>">Console</a>
	</td>
	<td align="right">
	  <%--a href="javascript:document.location.reload()">Reload</a> --%>
	  <a href="manage.jsp?server=<%= serverId %>">Reload</a>
	</td>
      </tr>
      <tr>
	<td><b>Location:</b></td>
	<td><%= server.getQueryAddress() %>:<%= server.getQueryPort() %></td>
      </tr>
      <tr>
	<td><b>Map:</b></td>
	<form method="post" action="manage.jsp">
	<td>
	  <input type="text" name="mapName" value="<%= server.getMapName() %>" size="16">
	  <input type="checkbox" name="keepTeams"> Keep teams
	  <input type="submit" value="Change" name="Change">
	</td>
	<td nowrap colspan="2">
	<b>rcon</b> <input type="text" name="rconCommand" size="16">
	  <input type="submit" value="Execute" name="Execute">
	</td>
	</form>
      </tr>
      <tr>
	<td><b>Players:</b></td>
	<td><%= server.getNumPlayers() %>/<%= server.getMaxPlayers() %></td>
      </tr>
    </table>
  </td>
</tr>
<%--
	<td><b>Players:</b></td><td><%= server.getPlayerStr() %></td>
--%>
   
  <tr>
    <th>#</th>
    <th>Name</th>
    <th>SrvrId</th>
    <th>WONId</th>
    <th>Frags</th>
    <th>Time</th>
    <th>Ping</th>
    <th>Address</th>
    <th>Kick</th>
    <th>Ban</th>
  </tr>
<%
  org.halfcat.halflife.StatusPlayer p;
  List playerList = server.getStatusPlayers();
  Iterator i = playerList.iterator();
  while ( i.hasNext() )
  {
    p = (org.halfcat.halflife.StatusPlayer)i.next();
%>
<tr>
  <td align="right"><%= p.getSeqNum() %></td>
  <td><%= p.getPlayerName() %> </td>
  <td align="center"><%= p.getNumber() %></td>
<%
  if ( org.halfcat.persistence.DataSource.isConnected() )
  {
%>
  <td align="right"><a href="playerProfile.jsp?wonId=<%= p.getWonID() %>" target="profile"><%= p.getWonID() %></a></td>
<% } else { %>
  <td align="right"><%= p.getWonID() %></td>
<% } %>

  <td align="right"><%= p.getFrags() %></td>
  <td align="right"><%= p.getConnectTimeStr() %></td>
  <td align="right"><%= p.getPing() %></td>
  <td align="right"><%= p.getAddress() %></td>
  <td><input type="checkbox" name="kick" value="<%= p.getWonID() %>"></td>
  <td>
    <input type="checkbox" name="ban" value="<%= p.getWonID() %>">
    <input type="text" name="<%= p.getWonID() %>" value="30" size="3">
  </td>
</tr>

<%
  } // endwhile

  if ( playerList.size() == 0 )
  {
%>
  <tr>
    <td colspan="10" align="center">
      <b>Server is Empty</b>
    </td>
  </tr>
<%
  }
%>
<tr>
  <td colspan="10" align="right">
    <input type="reset" name="Reset">
    <input type="submit" name="Kick/Ban" value="Kick/Ban">
  </td>
</tr>
</table>
</form>
<%
} // if ( serverUp )
%>
<hr>
<i>This page generated by <b>halfcat</b>.  Visit <a href="http://www.halfcat.org">http://www.halfcat.org</a> or mail us at <a href="mailto:halfcat@halfcat.org">halfcat@halfcat.org</a> for more information.</i>
<hr>
</center>
</body>
</html>
