<%@ 
  page language="java" 
  import="org.halfcat.halflife.*, java.util.*, java.net.*" 
%>
<jsp:useBean id="rconServers" scope="session" class="java.util.Hashtable" />
<jsp:useBean id="statusServers" scope="session" class="java.util.Hashtable" />

<%
  String referer =  request.getHeader( "referer" );
  System.out.println( "referer: " + referer );
  String delete = request.getParameter( "delete" );

  if ( session.isNew() )
  {
    System.out.println( "New Session" );
  }

  // see if we're removing a server
  if ( delete != null )
  {
    System.out.println( "Deleting" );
    if ( rconServers.containsKey( delete ) )
    {
      System.out.println( "Deleting: " + delete );
      rconServers.remove( delete );
      statusServers.remove( delete );
      Cookie[] ca = request.getCookies();
      for ( int x = 0; x < ca.length; x++ )
      {
	if ( ca[x].getName().equals( delete ) )
	{
	  ca[x].setMaxAge( 0 );
	  response.addCookie( ca[x] );
	}
      }
    }
  } // end if ( delete
  else if ( referer != null ) 
  {
    // process any submissions for login/add server here -- add a cookie
    // the cookie is url-encoded and formattted as 
    //  www.xxx.yyy.zzz:12345 1 passwd

    String newSvr = request.getParameter( "address" );
    if ( newSvr != null )
    {
      System.out.println( "Adding" );
      String newPort = request.getParameter( "port" );
      String svrType = request.getParameter( "rbMonitor" );
      String newPass = null;
      boolean doManage = false;
      if ( svrType != null && svrType.equals( "manage" ) )
      {
	doManage = true;
	newPass = request.getParameter( "password" );
      }
      if ( newPass == null )
	newPass = "";

      System.out.println( "newSvr: " + newSvr );
      System.out.println( "newPort: " + newPort );
      System.out.println( "svrType: " + svrType );
      System.out.println( "newPass: " + newPass );
      System.out.println( "doManage: " + doManage );

      if ( newPort != null )
      {
	// set the cookie for this server
	// "www.xxx.yyy.zzz:12345 1 passwd"
	// "www.xxx.yyy.zzz:12345 0 "
	String cookieValue = newSvr + ":" + newPort + " " + 
	  ( doManage ? "1" : "0" ) + " " + newPass;
	String cookieName  = "svr-" + rconServers.size();
	Cookie c = new Cookie( cookieName, URLEncoder.encode( cookieValue ) );
	c.setMaxAge( Integer.MAX_VALUE );
	response.addCookie( c );

	System.out.println( "new cookie: " + cookieName + ": " + cookieValue );

	if ( svrType != null && svrType.equals( "manage" ) )
	{
	  doManage = true;

	  RconServer rs = new RconServer();
	  rs.setQueryAddress( newSvr );
	  rs.setQueryPort( Integer.parseInt( newPort ) );
	  rs.setPassword( newPass );
	  rconServers.put( cookieName, rs );
	}
	StatusServer ss = new StatusServer();
	ss.setQueryAddress( newSvr );
	ss.setQueryPort( Integer.parseInt( newPort ) );
	statusServers.put( cookieName, ss );
      }
    }
  }
  else
    System.out.println( "none of the above" );
%>

<%
  // obtain and process cookies to get server list for new sessions
  if ( session.isNew() )
  {
    Cookie[] ca = request.getCookies();
    CookieProcessor.buildServersFromCookies( ca, rconServers, statusServers );
  } // session is new

  System.out.println( "Generating Page. " + statusServers.size() + " statusServers, " + rconServers.size() + " rconServers." );
%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>
<style type="text/css">
<!--
body { font-family: Arial, Helvetica, sans-serif; font-size: 9pt }
td {  font-family: Arial, Helvetica, sans-serif; font-size: 9pt}
th {  font-family: Arial, Helvetica, sans-serif; font-size: 9pt; font-weight: bold}
b { font-family: Arial, Helvetica, sans-serif; font-weight: bold; font-size: 9pt}
-->
</style>

<script language="Javascript">
<!--
function reloadPage() {
  document.location.reload();
}
//setTimeout( "location = 'servers.jsp'", 5000 );
//-->
</script>

<title>Monitor and Manage Servers</title>
</head>
<body>
<center>
<font face="Arial, Helvetica, sans-serif">
<table border="1" width="100%">
<tr>
  <td colspan="6" align="center">
    <table width="100%">
      <tr>
	<td>
	  <b>Monitor and Manage Servers</b>
	</td>
	<td align="right">
	  <a href="javascript:document.location.reload()">Reload</a>
	</td>
      </tr>
    </table>
  </td>
</tr>
  
<tr>
  <th>&nbsp;</th>
  <th>Name</th>
  <th>Map</th>
  <th>Players</th>
  <th>Location</th>
</tr>
<%
  int c = 1;
  Iterator i = statusServers.keySet().iterator();
  while ( i.hasNext() )
  {
    String key = (String)i.next();
    System.out.print( "checking status & rendering " + key + "..." );
    StatusServer server = (StatusServer)statusServers.get( key );

    try
    {
      //server.checkStatus();
      server.refresh();
      System.out.println( "refresh() succeeded." );
%>
    <tr>
      <td>
	  <%= c++ %>
      </td>
      <td>
<%
      if ( rconServers.containsKey( key ) )
      {
%>
	<a href="manage.jsp?server=<%= key %>" target="manage">
	  <%= server.getServerName() %></a>
<%
      }
      else
      {
%>
	<%= server.getServerName() %></a>
<%
      }
%>
      </td>

      <td>
	  <%= server.getMapName() %>
      </td>
      <td align="center">
	<a href="listPlayers.jsp?key=<%= key %>" target="manage">
	  <%= server.getNumPlayers() %>/<%= server.getMaxPlayers() %>
	</a>
      </td>
      <td align="right">
	  <%= server.getQueryAddress() %>:<%= server.getQueryPort() %>
      </td>
      <td align="center">
	<a href="servers.jsp?delete=<%= key %>">
	  <img src="/halfcat/images/red-x.png">
	</a>
      </td>
    </tr>
<%
    }
    catch( Exception e )
    {
      System.out.println( "checkStatus() failed." );
%>
    <tr>
      <td>
	  <%= c++ %></font>
      </td>
      <td colspan="3" align="center">
	  <b>Status check Failed</b>
      </td>
      <td align="right">
	  <%= server.getQueryAddress() %>:<%= server.getQueryPort() %>
      </td>
      <td align="center">
	<a href="servers.jsp?delete=<%= key %>">
	  <img src="/halfcat/images/red-x.png">
	</a>
      </td>
    </tr>
<%
    }
  } // while
%>
</table>
<!--
<hr>
<i>This page generated by <b>halfcat</b>.  Visit <a href="http://www.halfcat.org">http://www.halfcat.org</a> or mail us at <a href="mailto:halfcat@halfcat.org">halfcat@halfcat.org</a> for more information.</i>
<hr>
-->
</font>
</center>
</body>
</html>
