package org.halfcat.halflife;

import javax.servlet.http.*;
import javax.servlet.*;
import java.util.*;
import org.halfcat.persistence.*;
import org.halfcat.halflife.*;
import org.halfcat.halflife.cstrike.*;
import javax.servlet.jsp.*;

/**
 * Insert the type's description here.
 * Creation date: (8/31/00 11:29:27 AM)
 * @author: Administrator
 */
public class InitializerServlet 
	extends HttpServlet 
{
	private boolean initialized = false;
/**
 * InitializerServlet constructor comment.
 */
public InitializerServlet() 
{
	super();
	System.out.println( "Initializer Servlet constructing" );
}
/**
 * This method was imported from a .class file.
 * No source code is available.
 */
protected void doGet( HttpServletRequest req, HttpServletResponse resp ) 
	throws javax.servlet.ServletException, java.io.IOException 
{
	System.out.println( "do get" );
}
/**
 * This method was imported from a .class file.
 * No source code is available.
 */
public void init() throws javax.servlet.ServletException 
{
	System.out.println( "Emtpy init called...forwarding" );
	init( getServletConfig() );
}
/**
 * This method was imported from a .class file.
 * No source code is available.
 */
public void init( javax.servlet.ServletConfig config ) 
	throws javax.servlet.ServletException 
{
	if ( ! initialized )
	{
		System.out.println( "-----------" );
		System.out.println( "Initializing with context" );

		Enumeration e = config.getInitParameterNames();
		while ( e.hasMoreElements() )
		{
		  String attr = (String)e.nextElement();
		  System.out.println( attr + ":\t" + config.getInitParameter( attr ) );
		}
		System.out.println( "-----------" );
		
		boolean dbEnabled = Boolean.valueOf( config.getInitParameter( "dbEnabled" ) ).booleanValue();

		if ( ! dbEnabled )
		{
			System.out.println( "DB Connection disabled" );
		}
		else
		{
			System.out.println( "Connecting to Database now" );
			// should read these from a properties file...
			String hostname = config.getInitParameter( "dbHost" );
			String dbName = config.getInitParameter( "dbName" );
			String login = config.getInitParameter( "dbLogin" );
			String passwd = config.getInitParameter( "dbPassword" );
			String dbPort = config.getInitParameter( "dbPort" );
					
			try
			{
				String dbURL = DataSource.createDbUrl( hostname, dbName, Integer.parseInt( dbPort ), null );
				DataSource.connectToDB( dbURL, login, passwd );
			}
			catch( Exception ee )
			{
				ee.printStackTrace();
			}
		}
		System.out.println( "-----------\nStarting Parser" );
		boolean ptD = ParserThread.debug;
		ParserThread.debug = true;

		boolean processing = Boolean.valueOf( config.getInitParameter( "loaderMode" ) ).booleanValue();
		
		ParserThread.setProcessing( processing );
		PlayerSource.processing = processing;
		GameSource.processing   = processing;
		MapSource.processing    = processing;


		ParserThread.debug = ptD;
		System.out.println( "-----------\nLogListener" );

		boolean console = Boolean.valueOf( config.getInitParameter( "console" ) ).booleanValue();
		if ( console )
		{
			String listenPort = config.getInitParameter( "listenPort" );
			int lp = 4444;
			
			if ( listenPort != null )
			{
				try
				{
					lp = Integer.parseInt( listenPort );
				}
				catch( Exception ee )
				{
					System.out.println( "Failed to process 'listenPort'...using default " + lp );
				}
			}
					
			LogMessageListener ll = LogMessageListener.getInstance( lp );
			ll.setPortRemappingEnabled( Boolean.valueOf( config.getInitParameter( "portRemappingEnabled"  ) ).booleanValue() );
			ll.setDebug( Boolean.valueOf( config.getInitParameter( "listenerDebug" ) ).booleanValue() );
		}
		else
		
			System.out.println( "No LogListener -- Console Disabled" );
			
		System.out.println( "-----------" );
		
		initialized = true;
	}
	else
	{
		System.out.println( "Initializer already initialized" );
	}
		
}
/**
 * service method comment.
 */
public void service( javax.servlet.ServletRequest req, javax.servlet.ServletResponse resp ) 
	throws javax.servlet.ServletException, java.io.IOException 
{
//	ServletOutputStream out = resp.getOutputStream();
	System.out.println( "service" );
}
}
