package org.halfcat.halflife;

import java.text.*;
import java.io.*;
import java.net.*;
import java.util.*;
import org.halfcat.persistence.*;
/**
 * Insert the type's description here.
 * Creation date: (8/10/00 3:28:04 PM)
 * @author: Chandler Howell
 */
public class LogCatcher
	implements Runnable
{
	int listenPort = 4444;
	DatagramSocket theServer = null;
	List listenerList = new ArrayList();

	Hashtable fileHash = new Hashtable();

	// The directory to put logs in
	String logDir = "d:\\halflogs";

	// string to prepend to each file. i.e. "cstrike-"
	String filePrefix = "";

	// whether or not to echo the log file to the console
	boolean echoLogs = false;

	// if true, use the fileprefix + a sequence # to identify
	// connections when echoing logs (cuts the line width down a LOT)
	boolean shortName = true;

	// if true, check each line for "Log closed" message and
	// create a new file
	boolean checkClose = true;

	ParserThread pt;// = new ParserThread();	
	
/**
 * ListenServer constructor comment.
 */
public LogCatcher()
{
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (8/10/00 3:32:59 PM)
 */
public void bindToPort()
	throws java.io.IOException
{
	bindToPort( listenPort );
}
/**
 * Insert the method's description here.
 * Creation date: (8/10/00 3:32:59 PM)
 */
public void bindToPort( int portNumber )
	throws java.io.IOException
{
	System.out.println( "Binding to port: " + portNumber );
	listenPort = portNumber;
	theServer = new DatagramSocket( listenPort );
}
/**
 * Insert the method's description here.
 * Creation date: (8/10/00 3:28:19 PM)
 * @param args java.lang.String[]
 */
public static void main(String[] args) 
{

	String dbURL = DataSource.createDbUrl( "192.168.1.7", "hlstat", null );
	DataSource.connectToDB( dbURL, "howellc", "howellc" );

	
	LogCatcher ls = new LogCatcher();
	ls.processCmdLine( args );	
	try
	{
		System.out.println( "binding..." );
		ls.bindToPort( 4444 );
		Thread t = new Thread( ls );
		t.start();
	}
	catch( IOException ioe )
	{
		ioe.printStackTrace();
	}
}
/**
 * Insert the method's description here.
 * Creation date: (8/15/00 8:50:34 AM)
 */
private void printUsage( String progName ) 
{
	System.out.println( "Usage: " + progName + " [-d <logdir>] [-f <fileprefix>] [-e] [-s] [-c]" );
	System.out.println( "\t-e:  Echo logs to the console as they are received" );
	System.out.println( "\t-s:  Use short notation when echoing logs (<fileprefix>{1,2,3...}" );
	System.out.println( "\t\tinstead of <fileprefix><ipaddr>-<port>" );	
	System.out.println( "\t-c:  Disable checking files for \"Log closed\" message and create a new file for each logfile" );
}
/**
 * Insert the method's description here.
 * Creation date: (8/15/00 8:42:36 AM)
 * @param args java.lang.String[]
 */
public void processCmdLine(String[] args) 
{
	// Parse the command-line
	int x = 0;
	while ( x < args.length )
	{
		if ( args[x].equals( "-d" ) )
		{
			logDir = args[++x];
		}
		else if ( args[x].equals( "-p" ) )
		{
			try
			{
				listenPort = Integer.parseInt( args[++x] );
			}
			catch( Exception e )
			{
				printUsage( "usage:" );
				System.exit( 0 );
			}
		}		
		else if ( args[x].equals( "-f" ) )
		{
			filePrefix = args[++x];
		}
		else if ( args[x].equals( "-e" ) )
		{
			echoLogs = true;
		}
		else if ( args[x].equals( "-c" ) )
		{
			checkClose = false;
		}
		else
		{
			printUsage( args[0] );
			System.exit( 0 );
		}
		x++;		
	}
	
}
/**
 * run method comment.
 */
public void run() 
{
	boolean running = true;

	while ( running )
	{
		try
		{
			byte[] buf = new byte[256];

			// receive request
			DatagramPacket packet = new DatagramPacket(buf, buf.length );

			// this blocks until data is received
			theServer.receive( packet );
			writePacket( packet );
		}
		catch (IOException e)
		{
			e.printStackTrace();
			running = false;
		}
	}
	theServer.close();
}
/**
 * Insert the method's description here.
 * Creation date: (8/15/00 10:23:36 AM)
 * @param packet java.net.DatagramPacket
 */
private void writePacket(DatagramPacket packet)
	throws IOException
{
	InetAddress address = packet.getAddress();

	// this grabs just the valid portion of the string, including the newline
	// from the logstream
	String line = new String( packet.getData(), 8, (packet.getLength() - 9) );
	pt.parse( line );
	/*	
	String addressStr = address.getHostAddress();

	// generate the hash key and see if we have a LogConnection for this server
	// this is really a bad way to do this in any but a very small population, so
	// don't learn from this, kids
	String key = addressStr + ":" + packet.getPort();
	LogConnection lc;
	if ( fileHash.containsKey( key ) )
		lc = (LogConnection)fileHash.get( key );
	else
	{
		lc = new LogConnection( logDir, filePrefix, key );
		fileHash.put( key, lc );
		if ( shortName )
			lc.setShortName( filePrefix + fileHash.size() );
		else
			lc.setShortName( key );
	}

	lc.write( line, checkClose );
	if ( echoLogs )
		System.out.print( lc.getShortName() + " " + line );
*/			
}
}
