package org.halfcat.halflife;

import java.net.*;
import java.io.*;
import java.util.*;
import java.text.*;
import java.text.Format.*;

/**
 * Insert the type's description here.
 * Creation date: (8/15/00 9:58:02 AM)
 * @author: Chandler Howell
 */
public class LogConnection 
{
	private InetAddress address;
	private BufferedWriter outStream;
	private int sequence = 0;
	String fileBase = "";
	String shortName;

	// while these are both horribly expensive classes to instantiate,
	// they're also not threadsafe, so we'll just have one per connection.
	// shouldn't be a big deal, though, since most people will only be 
	// logging a handful of servers
	SimpleDateFormat sdf = new SimpleDateFormat( "MMddhhmm" );
	NumberFormat nf = NumberFormat.getInstance();	
/**
 * LogConnection constructor comment.
 */
private LogConnection() 
{
	super();

	nf.setMaximumIntegerDigits( 3 );
	nf.setMinimumIntegerDigits( 3 );
}
/**
 * LogConnection constructor comment.
 */
public LogConnection( String logDir, String logPrefix, String source )
	throws IOException
{
	super();
	// "d:\" + "{/\}" + "cstrike-" + "192.168.1.1:27017"
	fileBase = logDir + File.separator + logPrefix + source.replace( ':', '-' ) + "-" +
		sdf.format( new Date() );
	outStream = newFile( fileBase );	
}
/**
 * Insert the method's description here.
 * Creation date: (8/15/00 11:00:26 AM)
 * @return java.lang.String
 */
public java.lang.String getShortName() {
	return shortName;
}
/**
 * Insert the method's description here.
 * Creation date: (8/15/00 10:42:08 AM)
 * @return java.io.BufferedWriter
 * @param fileBase java.lang.String
 * @param sequence int
 */
private BufferedWriter newFile(String fileBase )
	throws IOException
{	
	File f = new File( fileBase + "-" + nf.format( ++sequence ) + ".log" );
	System.out.println( "*-*-*-*-Opening File: " + f.getAbsolutePath() );
	return new BufferedWriter( new FileWriter( f ) );	
		
}
/**
 * Insert the method's description here.
 * Creation date: (8/15/00 11:00:26 AM)
 * @param newShortName java.lang.String
 */
public void setShortName(java.lang.String newShortName) 
{
	shortName = newShortName;
}
/**
 * Insert the method's description here.
 * Creation date: (8/15/00 10:36:17 AM)
 * @param line java.lang.String
 * @param checkClose boolean
 * @exception java.io.IOException The exception description.
 */
public synchronized void write(String line, boolean checkClose) 
	throws java.io.IOException 
{
	outStream.write( line );
	
	if ( checkClose )
	{
		if ( line.indexOf( "Log closed." ) >= 0 )
		{
			System.out.println( "Logfile closing" );
			outStream.flush();
			outStream.close();
			outStream = newFile( fileBase );
		}
		else
			outStream.flush();
	}
}
}
