package org.halfcat.halflife;

import java.util.*;
import org.halfcat.persistence.*;

/**
 * Maintain a persistent map of serverId's to WON Id's so that
 * if the web server must be restarted, it won't lose track of who
 * the current players are for tracking purposes
 * Creation date: (8/29/00 6:35:22 PM)
 * @author: Administrator
 */
public class MapSource 
{
	private static Hashtable servers = new Hashtable();
	public static boolean processing = true;
/**
 * MapSource constructor comment.
 */
private MapSource() 
{
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (8/29/00 6:36:22 PM)
 * @param stw org.halfcat.halflife.ServerToWon
 */
public synchronized static void addMapping( int serverId, long wonId, int serverRecordId ) 
{
	Integer sri = new Integer( serverRecordId );
	Hashtable h = null;
	if ( servers.containsKey( sri ) )
	{
		h = (Hashtable)servers.get( sri );
//		h.clear();
	}
	else
	{
		h = new Hashtable();
		servers.put( sri, h );
	}
	
	// first player is joining, so flush the table
	if ( serverId == 1 )
	{
		try
		{
			if ( processing )
				DataManager.deleteAll( ServerToWon.class );
		}
		catch( Exception e )
		{
			e.printStackTrace();
		}
	}

	// if we alreadh have this mapping	
	Integer sId = new Integer( serverId );
	if ( h.containsKey( sId ) )
	{
		ServerToWon s = (ServerToWon)h.get( sId );
		if ( s.getWonID() == wonId )
			return;
		else
			removeMapping( s.getServerID(), serverRecordId );
	}
	try
	{
		ServerToWon stw = new ServerToWon( serverId, wonId, serverRecordId );
		if ( processing )
			DataManager.save( stw );
		h.put( sId, stw );
	}
	catch( Exception e )
	{
		System.out.println( "Failed to save ServerToWon" + e.getMessage() );
	}	
	
}
/**
 * Insert the method's description here.
 * Creation date: (8/29/00 6:42:29 PM)
 * @return long
 * @param serverId int
 */
public synchronized static long getMapping( int serverId, int serverRecordId ) 
{
	Integer i = new Integer( serverId );
	Integer sri = new Integer( serverRecordId );
	Hashtable h;
	
	if ( servers.containsKey( sri ) )
		h = (Hashtable)servers.get( sri );
	else
	{
		h = new Hashtable();
		servers.put( sri, h );
	}

	// have this mapping
	if ( h.containsKey( i ) )
		return ((ServerToWon)h.get( i )).getWonID();

	List l = DataManager.fetchLimited( ServerToWon.class, "serverId", i );	
	if ( l.size() > 0 )
	{
		Iterator ii = l.iterator();
		while ( ii.hasNext() )
		{
			ServerToWon stw = (ServerToWon)ii.next();
			if ( stw.getServer() == serverRecordId )
			{
				h.put( i, stw );
				return stw.getWonID();
			}
		}
	}
	return -1;		
}
/**
 * Remove a persistent mapping of serverId -> wonID
 * Creation date: (8/29/00 6:36:22 PM)
 * @param stw org.halfcat.halflife.ServerToWon
 */
public synchronized static void removeMapping( int serverId, int serverRecordId ) 
{
	Integer sId = new Integer( serverId );
	Integer iSr = new Integer( serverRecordId );
	
	try
	{
		Hashtable h = (Hashtable)servers.get( iSr );
		if ( h.containsKey( sId ) )
		{
			ServerToWon s = (ServerToWon)h.remove( sId );
			if ( processing )			
				DataManager.delete( s );
		}
		else
		{
			if ( processing )
				DataManager.deleteLimited( ServerToWon.class, "serverid", sId );
		}
	}
	catch( Exception e )
	{
		System.out.println( "Failed to save ServerToWon" + e.getMessage() );
	}
}
}
