package org.halfcat.halflife;

import java.io.*;
import java.net.*;
import java.util.*;
/**
 * Insert the type's description here.
 * Creation date: (8/22/00 7:47:33 AM)
 * @author: Administrator
 */
public class RconServer
	extends Server
{
	protected String password;

	String version;
	/** A List of StatusPlayer objects */
	List statusPlayers = new ArrayList();

	/** hack */
	String playerStr;

	Hashtable playerHash = new Hashtable();

/**
 * Rcon constructor comment.
 */
public RconServer() {
	super();
}
/**
 * Rcon constructor comment.
 */
public RconServer( String qAddress, int qPort )
	throws
		IOException,
		SocketException
{	
		super( qAddress, qPort );
}
/**
 * Rcon constructor comment.
 */
public RconServer( String qAddress, int qPort, String password )
	throws
		IOException,
		SocketException
{	
		super( qAddress, qPort );
		this.password = password;
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 4:49:10 PM)
 * @param wonID long
 * @param numMinutes int
 * @exception java.io.IOException The exception description.
 * @exception java.net.SocketException The exception description.
 */
public void ban( long wonID, int numMinutes) 
	throws java.io.IOException, 
	java.net.SocketException 
{
	ban( wonID, numMinutes, false );
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 4:49:10 PM)
 * @param wonID long
 * @param numMinutes int
 * @param kick boolean
 * @exception java.io.IOException The exception description.
 * @exception java.net.SocketException The exception description.
 */
public void ban( long wonID, int numMinutes, boolean kick ) 
	throws 
		java.io.IOException, 
		java.net.SocketException 
{
	StringBuffer banCmd = new StringBuffer( "rcon \"" + password + "\" \"banid\" \"" );
	banCmd.append( numMinutes );
	banCmd.append( "\" \"" );
	banCmd.append( wonID );
	banCmd.append( "\"" );
	if ( kick )
		banCmd.append( " \"kick\"" );

	System.out.println( "RconServer.ban() sending: " + banCmd );
	sendCommand( banCmd.toString() );

	// only write permanant bans
	if ( numMinutes == 0 )
		sendCommand( "writeid" ); 
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 5:01:18 PM)
 * @return java.util.List
 * @exception java.io.IOException The exception description.
 * @exception java.net.SocketException The exception description.
 */
public List getMaps() 
	throws 
		java.io.IOException, 
		java.net.SocketException 
{
	ArrayList al = new ArrayList();
	
	byte[] buf = sendCommand( "maps cstrike" );
	printBytes( buf, buf.length, true );
	return al;
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 12:42:57 PM)
 * @return java.lang.String
 */
private java.lang.String getPassword() {
	return password;
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 5:29:41 PM)
 * @return java.lang.String
 */
public java.lang.String getPlayerStr() {
	return playerStr;
}
/**
 * Insert the method's description here.
 * Creation date: (8/23/00 1:08:13 PM)
 * @return int
 * @param wonId long
 */
public int getServerId( long wonId ) 
{
	Long l = new Long( wonId );
	if ( playerHash.containsKey( l ) )
	{
		StatusPlayer sp = (StatusPlayer)playerHash.get( l );
		return sp.getNumber();
	}

	return -1;
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 12:49:55 PM)
 * @return java.util.List
 */
public java.util.List getStatusPlayers()
	throws
		MessageFailedException
{
	return statusPlayers;
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 12:42:44 PM)
 * @return java.lang.String
 */
public java.lang.String getVersion() {
	return version;
}
/**
 * Insert the method's description here.
 * Creation date: (8/24/00 10:25:39 AM)
 * @return long
 */
public long getWaitInMillis() {
	return waitInMillis;
}
/**
 * Kick player # serverID
 * Creation date: (8/22/00 4:47:08 PM)
 * @param serverID int
 * @exception java.io.IOException The exception description.
 * @exception java.net.SocketException The exception description.
 */
public void kick( int serverID )
	throws
		SocketException,
		IOException
{
	String kickCmd = "rcon \"" + password + "\" \"kick\" \"#" + serverID + "\"";
	System.out.println( "RconServer.kick() sending: " + kickCmd );
	sendCommand( kickCmd );
}
/**
 * Kick a player based on their WON ID
 * Creation date: (8/22/00 4:47:08 PM)
 * @param wonID long
 * @exception java.io.IOException The exception description.
 * @exception java.net.SocketException The exception description.
 */
public void kick( long wonID )
	throws
		SocketException,
		IOException
{	
	String kickCmd = "rcon \"" + password + "\" \"kick\" \"#" + wonID + "\""; 
	System.out.println( "RconServer.kick() sending: " + kickCmd );
	sendCommand( kickCmd );
}
/**
 * Starts the application.
 * @param args an array of command-line arguments
 */
public static void main(java.lang.String[] args) 
{
	boolean checkStatus = false;
	boolean ping = false;
	// Insert code to start the application here.
	try
	{
		InetAddress address = InetAddress.getByName( "192.168.1.6" );
//		RconServer rcon = new RconServer( "192.168.1.7", 27017, "t3xas" );
		RconServer rcon = new RconServer( "192.168.1.7", 27017, "t3xas" );
//		RconServer rcon = new RconServer( "192.168.1.6", 27019, "t3xas" );

		if ( ping )
		{
			System.out.print( "Pinging " + rcon.getQueryAddress() + "..." );
			if ( rcon.ping() )
				System.out.println( "up" );
			else
				System.out.println( "down." );
		}

		byte[] ba = rcon.sendCommand( "maps cstrike" );
		if ( ba != null )
		{
			rcon.printBytes( ba, ba.length, false );
		}
		else
			System.out.println( "null back" );
			
		if ( checkStatus )
		{
			rcon.refresh();
			System.out.println( "Server: "  + rcon.getServerName() );
			System.out.println( "Version: " + rcon.getVersion() );
			System.out.println( "Map: '"     + rcon.getMapName() + "'" );
			System.out.println( "Address: " + rcon.getAddress() + ":" + rcon.getPort() );
	
			System.out.println( "Players: " );
			StatusPlayer p;
			Iterator i = rcon.getStatusPlayers().iterator();
			while ( i.hasNext() )
			{
				p = (StatusPlayer)i.next();
				System.out.println( "" + p.getSeqNum() + "\t" + p.getPlayerName() + "\t" +
						p.getNumber() + "  " + p.getWonID() + "\t" + p.getFrags() + "\t" + p.getPing() +
						"\t" + p.getAddress() + ":" + p.getPort() );
			}
		}

//		rcon.kick( (int)647 );

//		int sId = rcon.getServerId( Long.parseLong( "18216799" ) );
//    System.out.println( "Kick: " + kickIds[x] + "->" + sId );
//	rcon.kick( sId );

		rcon = new RconServer( "192.168.1.6", 27019, "t3xas" );

		if ( ping )
		{
			System.out.print( "Pinging " + rcon.getQueryAddress() + "..." );
			if ( rcon.ping() )
				System.out.println( "up" );
			else
				System.out.println( "down." );
		}
			
		if ( checkStatus )
		{
			rcon.refresh();
			System.out.println( "Server: "  + rcon.getServerName() );
			System.out.println( "Version: " + rcon.getVersion() );
			System.out.println( "Map: '"     + rcon.getMapName() + "'" );
			System.out.println( "Address: " + rcon.getAddress() + ":" + rcon.getPort() );
	
			System.out.println( "Players: " );
			StatusPlayer p;
			Iterator i = rcon.getStatusPlayers().iterator();
			while ( i.hasNext() )
			{
				p = (StatusPlayer)i.next();
				System.out.println( "" + p.getSeqNum() + "\t" + p.getPlayerName() + "\t" +
						p.getNumber() + "  " + p.getWonID() + "\t" + p.getFrags() + "\t" + p.getPing() +
						"\t" + p.getAddress() + ":" + p.getPort() );
			}
		}
		
//		rcon.sendCommand( "rcon \"t3xas\" \"status\"", address, 27017 );
		
//		rcon.sendCommand( "rcon \"t3xas\" \"say\" \"hola\"", address, 27017 );
//		rcon.sendCommand( "rcon \"t3xas\" \"say\" \"what's up?\"", address, 27017 );
	}
	catch( Exception e )
	{
		System.out.println( e.getMessage() );
		e.printStackTrace();
	}
	System.exit( 0 );
}
/**
 * Send a formatted rcon command to the server
 * Creation date: (8/22/00 8:38:30 AM)
 * @param message java.lang.String the message to say as the server
 */
public void rconCommand( String message )
	throws MessageFailedException
{	
	try
	{
		sendCommand( "rcon \"" + password + "\" \"" + message + "\"" );
	}
	catch( Exception e )
	{
		throw new MessageFailedException( "Message '" + message + "' failed b/c: " + e.getMessage() );
	}
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 10:31:42 AM)
 * @exception java.io.IOException The exception description.
 * @exception java.net.SocketException The exception description.
 */
public void refresh() 
	throws
		BadPasswordException,
		java.io.IOException, 
		java.net.SocketException 
{
	byte[] resp = sendCommand( "\"rcon\" \"" + password + "\" \"status\"" );

	if ( resp == null )	
		throw new SocketException( "No respose from host." );

//	printBytes( resp, resp.length, true );
	String response = new String( resp, 1, resp.length - 1 );
	
	if ( debug )
		System.out.println( "'" + response + "'" );
		
	if ( response.startsWith( "Bad rcon_password" ) )
	 throw new BadPasswordException( "Bad rcon_password for " + queryAddress + ":" + queryPort );
	 
	StringTokenizer st = new StringTokenizer( response, ":\n" );
	
	//
	// Parse server info
	//
	
	st.nextToken();	
	setServerName( st.nextToken().trim() );

	st.nextToken();	
	setVersion( st.nextToken().trim() );

	st.nextToken();	
	setAddress( st.nextToken().trim() );
	setPort( Integer.parseInt( st.nextToken() ) );

	st.nextToken();
	String mName = st.nextToken();
	setMapName( mName.substring( 2, mName.length() - 3 ) );
	st.nextToken();

	st.nextToken();		
	playerStr = st.nextToken();
	playerStr = playerStr.substring( 1 );
	String numStr = playerStr.substring( 0, playerStr.indexOf( ' ' ) );
	numPlayers = Integer.parseInt( numStr );
	String active = playerStr.substring( playerStr.indexOf( '(' ) + 1 );
	maxPlayers = Integer.parseInt( active.substring( 0, active.indexOf( ' ' ) ) );

/*
	System.out.println( "serverName: '" + servername +"'" );
	System.out.println( "version: '" + version +"'" );
	System.out.println( "address: '" + address +":" + port +"'" );
	System.out.println( "players: '" + players +"'" );
	System.out.println( "map: '" + map +"'" );
*/	

	//
	//
	// parse players
	//
	//

	// skip the blank line before the players are listed
//	st.nextToken();
	// skip the header line for the player list
	st.nextToken();
	
	// use a stack to parse the machine-created stuff, then just
	// concatenate all the leftover but two (the '#' & player num )
	// to form the name
	Stack stack = new Stack();

	statusPlayers.clear();
	playerHash.clear();
	StatusPlayer p;
	
	while ( st.hasMoreTokens() )
	{
		p = new StatusPlayer();
		int index;
		// chop off the leading '#'
		String pStr = st.nextToken( "\n" ).substring( 1 );
		if ( pStr.length() < 10 )
			continue;
		StringTokenizer st1 = new StringTokenizer( pStr );

		stack.clear();
		while ( st1.hasMoreTokens() )
			stack.push( st1.nextToken() );

		p.setAddress( (String)stack.pop() );
		p.setDroppedPackets( Integer.parseInt( (String)stack.pop() ) );
		p.setPing( Integer.parseInt( (String)stack.pop() ) );
		p.setConnectTimeStr( (String)stack.pop() );
		p.setFrags( Integer.parseInt( (String)stack.pop() ) );
		p.setWonID( Long.parseLong( (String)stack.pop() ) );
		p.setNumber( Integer.parseInt( (String)stack.pop() ) );

		StringBuffer sb = new StringBuffer();
		for ( int x = 1; x < stack.size(); x++ )
		{
			sb.append( stack.elementAt( x ) );
			if ( ( x + 1 ) < stack.size() )
				sb.append( ' ' );
		}
		
//		System.out.println( "player name: " + sb.toString() );
		p.setPlayerName( sb.toString() );
			
		try
		{
			p.setSeqNum( Integer.parseInt( (String)stack.elementAt( 0 ) ) );
		}
		catch( Exception e )
		{
			System.out.println( p.getPlayerName() + " Failed on '" + stack.elementAt( 0 ) + "'" );
			e.printStackTrace();
		}
		statusPlayers.add( p );
		playerHash.put( new Long( p.getWonID() ), p );
/*		
		if ( stack.pop().equals( "#" ) )
			System.out.println( "looks good" );				

		System.out.println( "pSeqNum '" + pSeqNum + "'" );
		System.out.println( "pName '" + pName + "'"	);
		System.out.println( "pServNum '" + pServNum + "'" );
		System.out.println( "pWonId '" + pWonId + "'" );
		System.out.println( "pFrags '" + pFrags + "'" );
		System.out.println( "pTime '" + pTime + "'" );
		System.out.println( "pPing'" + pPing + "'" );
		System.out.println( "pDrop'" + pDrop + "'" );
		System.out.println( "pAddr'" + pAddr + "'" );
		System.out.println( "---" );
*/		
	}
}
/**
 * "say" something as the server operator
 * Creation date: (8/22/00 8:38:30 AM)
 * @param message java.lang.String the message to say as the server
 */
public void say( String message )
	throws MessageFailedException
{	
	try
	{
		sendCommand( "rcon \"" + password + "\" \"say\" \"" + message + "\"" );
	}
	catch( Exception e )
	{
		throw new MessageFailedException( "Message failed b/c: " + e.getMessage() );
	}
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 12:42:57 PM)
 * @param newPassword java.lang.String
 */
public void setPassword(java.lang.String newPassword) {
	password = newPassword;
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 5:29:41 PM)
 * @param newPlayerStr java.lang.String
 */
public void setPlayerStr(java.lang.String newPlayerStr) {
	playerStr = newPlayerStr;
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 12:49:55 PM)
 * @param newStatusPlayers java.util.List
 */
private void setStatusPlayers(java.util.List newStatusPlayers) {
	statusPlayers = newStatusPlayers;
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 12:42:44 PM)
 * @param newVersion java.lang.String
 */
public void setVersion(java.lang.String newVersion) {
	version = newVersion;
}
/**
 * Insert the method's description here.
 * Creation date: (8/24/00 10:25:39 AM)
 * @param newWaitInMillis long
 */
public void setWaitInMillis(long newWaitInMillis) {
	waitInMillis = newWaitInMillis;
}
}
