package org.halfcat.halflife;

import java.io.*;
import java.net.*;
import java.util.*;
/**
 * Insert the type's description here.
 * Creation date: (8/22/00 8:43:29 AM)
 * @author: Administrator
 */
public class Server 
{
	// used by constructor/query mechanism
	protected String queryAddress;
	protected int queryPort;
	public static boolean debug = false;

	String mapName;
	// the address & port as reported by the server--not what you probably really want
	String address;
	String serverName;
	int port;

	int numPlayers;
	int maxPlayers;

	protected long waitInMillis = 1000;

	
  /**
   * The specific byte arrays for firing off the queries
   **/
/*   
  // ping
  public final static byte[] HL_PING = new byte[] 
	{ (byte)'\377', (byte)'\377', (byte)'\377', (byte)'\377', (byte)'p', (byte)'i', (byte)'n', (byte)'g', (byte)'\0' };

  // server vars/rules
  public final static byte[] HL_RULES = new byte[] 
	{ (byte)'\377', (byte)'\377', (byte)'\377', (byte)'\377', (byte)'r', (byte)'u', (byte)'l', (byte)'e', (byte)'s', (byte)'\0' };

  //
  public final static byte[] HL_INFO = new byte[] 
	{ (byte)'\377', (byte)'\377', (byte)'\377', (byte)'\377', (byte)'i', (byte)'n', (byte)'f', (byte)'o', (byte)'\0' };


  // get the list of servers from a master server
  public final static byte[] HL_MASTER = new byte[] 
	{ (byte)'e', (byte)'\0', (byte)'\0', (byte)'\0' };
*/		
  // player list
  public final static byte[] HL_PLAYERS = new byte[] 
	{ (byte)'\377', (byte)'\377', (byte)'\377', (byte)'\377', (byte)'p', (byte)'l', (byte)'a', (byte)'y', (byte)'e', (byte)'r', (byte)'s', (byte)'\0' };
/**
 * Server constructor comment.
 */
public Server() {
	super();
}
/**
 * Server constructor comment.
 */
public Server( String qAddress, int qPort )
	throws
		IOException,
		SocketException
{
	super();
	queryAddress = qAddress;
	queryPort = qPort;
//	refresh();
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:06 AM)
 * @return java.lang.String
 */
public java.lang.String getAddress() {
	return address;
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:06 AM)
 * @return java.lang.String
 */
public java.lang.String getMapName() {
	return mapName;
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:06 AM)
 * @return int
 */
public int getMaxPlayers() {
	return maxPlayers;
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:29 AM)
 * @return int
 */
public int getNumPlayers() {
	return numPlayers;
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:06 AM)
 * @return int
 */
public int getPort() {
	return port;
}
/**
 * Insert the method's description here.
 * Creation date: (8/20/00 1:50:17 PM)
 * @return java.lang.String
 */
public java.lang.String getQueryAddress() {
	return queryAddress;
}
/**
 * Insert the method's description here.
 * Creation date: (8/20/00 1:50:17 PM)
 * @return int
 */
public int getQueryPort() {
	return queryPort;
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:06 AM)
 * @return java.lang.String
 */
public java.lang.String getServerName() {
	return serverName;
}
/**
 * Return true if the host is up, false if it is down
 * or does not respond
 * Creation date: (8/24/00 8:22:55 AM)
 * @return boolean true if host is up
 */
public boolean ping()
{
	try
	{
		InetAddress ia = InetAddress.getByName( queryAddress );
		
		byte[] resp = sendCommand( "ping", ia, queryPort );		
		return ( resp != null);
	}
	catch (Exception e)
	{
		e.printStackTrace();
		return false;
	}
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 7:47:52 AM)
 */
protected void printBytes( byte[] buf, int length, boolean showHex )
{
		// display response
		System.out.println("Received " + length + " bytes back." );

		if ( showHex )
		{	
			for (int x = 0; x < length; x++)
			{
				if ( buf[x] == (char)13 || buf[x] == (char)10 )
					System.out.println( "" );
				System.out.print(" " + (int) buf[x]);
			}
			System.out.println("");
		}


		// print the characters
		for (int x = 0; x < length - 1 ; x++)
		{
			char c;
			if (buf[x] != (byte) 0)
			{
				c = (char) buf[x];
			}
			else
				c = ' ';
			System.out.print(c);
		}
		System.out.println("");	
}
/**
 * Send a raw rcon command to the server
 * Creation date: (8/19/00 7:32:52 AM)
 * @return byte[]
 * @param address java.lang.String
 * @param port int
 */
protected byte[] sendCommand( String command )
	throws 
		SocketException,
		UnknownHostException,
		IOException
	
{
	return sendCommand( command, InetAddress.getByName( queryAddress ), queryPort );
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:32:52 AM)
 * @return byte[]
 * @param address java.lang.String
 * @param port int
 */
protected byte[] sendCommand( String command, String address, int port )
	throws 
		SocketException,
		UnknownHostException,
		IOException
	
{
	return sendCommand( command, InetAddress.getByName( address ), port );
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:32:52 AM)
 * @return byte[]
 * @param address java.lang.String
 * @param port int
 */
protected byte[] sendCommand( String command, InetAddress address, int port )
	throws 
		SocketException,
		UnknownHostException,
		IOException
	
{
	if ( debug )
		System.out.println( "sendCommand(): " + command );
		
	UdpMessageThread umt = new UdpMessageThread();
	umt.setAddress( address );
	umt.setPort( port );
	umt.setMessage( command );

	try
	{
		umt.start();
		umt.join( waitInMillis );
	}
	catch( InterruptedException ie )
	{
		if ( debug )
			System.out.println( "Interrupted: " + ie.getMessage() );
	}
	return umt.getResponse();
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:06 AM)
 * @param newAddress java.lang.String
 */
public void setAddress(java.lang.String newAddress) {
	address = newAddress;
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:06 AM)
 * @param newMapName java.lang.String
 */
public void setMapName(java.lang.String newMapName) {
	mapName = newMapName;
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:06 AM)
 * @param newMaxPlayers int
 */
public void setMaxPlayers(int newMaxPlayers) {
	maxPlayers = newMaxPlayers;
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:29 AM)
 * @param newNumPlayers int
 */
private void setNumPlayers(int newNumPlayers) {
	numPlayers = newNumPlayers;
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:06 AM)
 * @param newPort int
 */
public void setPort(int newPort) {
	port = newPort;
}
/**
 * Insert the method's description here.
 * Creation date: (8/20/00 1:50:17 PM)
 * @param newQueryAddress java.lang.String
 */
public void setQueryAddress(java.lang.String newQueryAddress) {
	queryAddress = newQueryAddress;
}
/**
 * Insert the method's description here.
 * Creation date: (8/20/00 1:50:17 PM)
 * @param newQueryPort int
 */
public void setQueryPort(int newQueryPort) {
	queryPort = newQueryPort;
}
/**
 * Insert the method's description here.
 * Creation date: (8/19/00 7:39:06 AM)
 * @param newServerName java.lang.String
 */
public void setServerName(java.lang.String newServerName) {
	serverName = newServerName;
}
}
