package org.halfcat.halflife;

import java.io.*;
import java.net.*;
/**
 * Insert the type's description here.
 * Creation date: (8/24/00 8:42:09 AM)
 * @author: Administrator
 */
public class UdpMessageThread 
	extends Thread 
{
	String message = null;
	public static boolean debug = false;
	
	InetAddress address = null;
	int port = 0;

	byte[] response = null;
/**
 * UdpMessageThread constructor comment.
 */
public UdpMessageThread() {
	super();
}
/**
 * UdpMessageThread constructor comment.
 * @param target java.lang.Runnable
 */
public UdpMessageThread(Runnable target) 
{
	super(target);
}
/**
 * UdpMessageThread constructor comment.
 * @param target java.lang.Runnable
 * @param name java.lang.String
 */
public UdpMessageThread(Runnable target, String name) {
	super(target, name);
}
/**
 * UdpMessageThread constructor comment.
 * @param name java.lang.String
 */
public UdpMessageThread(String name) 
{
	super(name);
}
/**
 * UdpMessageThread constructor comment.
 * @param group java.lang.ThreadGroup
 * @param target java.lang.Runnable
 */
public UdpMessageThread(ThreadGroup group, Runnable target) {
	super(group, target);
}
/**
 * UdpMessageThread constructor comment.
 * @param group java.lang.ThreadGroup
 * @param target java.lang.Runnable
 * @param name java.lang.String
 */
public UdpMessageThread(ThreadGroup group, Runnable target, String name) {
	super(group, target, name);
}
/**
 * UdpMessageThread constructor comment.
 * @param group java.lang.ThreadGroup
 * @param name java.lang.String
 */
public UdpMessageThread(ThreadGroup group, String name) {
	super(group, name);
}
/**
 * Insert the method's description here.
 * Creation date: (8/24/00 10:10:04 AM)
 * @return java.net.InetAddress
 */
public java.net.InetAddress getAddress() {
	return address;
}
/**
 * Insert the method's description here.
 * Creation date: (8/24/00 10:08:53 AM)
 * @return java.lang.String
 */
public java.lang.String getMessage() {
	return message;
}
/**
 * Insert the method's description here.
 * Creation date: (8/24/00 10:10:04 AM)
 * @return int
 */
public int getPort() {
	return port;
}
/**
 * Insert the method's description here.
 * Creation date: (8/24/00 10:10:47 AM)
 * @return byte[]
 */
public byte[] getResponse() 
{
	return response;
}
/**
 * Insert the method's description here.
 * Creation date: (8/22/00 7:47:52 AM)
 */
protected void printBytes( byte[] buf, int length, boolean showHex )
{
		// display response
		System.out.println("Received " + length + " bytes back." );

		if ( showHex )
		{	
			for (int x = 0; x < length; x++)
			{
				if ( buf[x] == (char)13 || buf[x] == (char)10 )
					System.out.println( "" );
				System.out.print(" " + (int) buf[x]);
			}
			System.out.println("");
		}


		// print the characters
		for (int x = 0; x < length - 1 ; x++)
		{
			char c;
			if (buf[x] != (byte) 0)
			{
				c = (char) buf[x];
			}
			else
				c = ' ';
			System.out.print(c);
		}
		System.out.println("");	
}
/**
 * Insert the method's description here.
 * Creation date: (8/24/00 9:04:37 AM)
 */
public void run() 
{
	DatagramSocket socket = null;
	try
	{
		// get a datagram socket
		 socket = new DatagramSocket();

		byte[] messageBytes = new byte[message.length() + 5];

		// pack header
		for ( int x = 0; x < 4; x++ )	
			messageBytes[x] = (byte)0xff;

		// pack the actual message
		byte[] cmd = message.getBytes();
		for ( int y = 0; y < cmd.length; y++ )
			messageBytes[y+4] = cmd[y];

		messageBytes[cmd.length+4] = (byte)0x00;
		
		DatagramPacket packet = new DatagramPacket( messageBytes, messageBytes.length, address, port );
		socket.send( packet );
	
		// get response
		byte[] response = new byte[4096];
		packet = new DatagramPacket( response, response.length );
		if ( debug )
			System.out.println( "waiting..." );
		socket.receive( packet );

		if ( debug )
			System.out.println( "Received " + packet.getLength() + " bytes." );

		byte[] dst = new byte[packet.getLength() - 4];
		System.arraycopy(packet.getData(), 4, dst, 0, (packet.getLength() - 4));

		if ( debug )
		{
			printBytes( dst, dst.length, true );
		}

		setResponse( dst );		
	}
	catch( Exception e )
	{
		e.printStackTrace();
	}
	finally
	{
		if ( socket != null )
		{
			if ( debug )
				System.out.println( "Closing socket" );
			socket.close();
		}
	}
}
/**
 * Insert the method's description here.
 * Creation date: (8/24/00 10:10:04 AM)
 * @param newAddress java.net.InetAddress
 */
public void setAddress(java.net.InetAddress newAddress) {
	address = newAddress;
}
/**
 * Insert the method's description here.
 * Creation date: (8/24/00 10:08:53 AM)
 * @param newMessage java.lang.String
 */
public void setMessage(java.lang.String newMessage) {
	message = newMessage;
}
/**
 * Insert the method's description here.
 * Creation date: (8/24/00 10:10:04 AM)
 * @param newPort int
 */
public void setPort(int newPort) {
	port = newPort;
}
/**
 * Insert the method's description here.
 * Creation date: (8/24/00 10:10:47 AM)
 * @param newResponse byte[]
 */
private void setResponse(byte[] newResponse) 
{
	response = newResponse;
}
}
