package org.halfcat.halflife.cstrike;

import java.net.*;
import java.util.*;
/**
 * Insert the type's description here.
 * Creation date: (8/13/00 11:38:50 AM)
 * @author: Administrator
 */
public class GamePlayer
	extends org.halfcat.persistence.AbstractPersistable
{
	private long wonID = 0;
	private int currentTeam = UNDEFINED;

	private int kills = 0;
	private int deaths = 0;

	// link back to the game these actions occurred in
	// maps to the ObjectID of the game
	private int gameId = 0;

	// not supported for now, but exists in DB
	private int tks = 0;

	//
	// tasks within the game
	//

	// cs_ tasks
	private int touchedHostages = 0;
	private int rescuedHostages = 0;
	private int killedHostages  = 0;

	// de_ tasks
	private int bombPlants      = 0;
	private int bombDefuses     = 0;

	// as_ tasks
	private int vipKills        = 0;

	// es_tasks -- not supported for now,
	// included for future expansion
	private int escapes         = 0;

	// track the # of times a person reconnects during a game	
	private int reconnects = 0;
	
	// when they join and first select a team, this will
	// increment to 0
	private int teamChangeCount = -1;

	private int serverId = 0;

	// which team
	public static final int UNDEFINED = 0;
	public static final int TERRORIST = 1;
	public static final int COUNTERTERRORIST = 2;

	// the player ( wonID/aliases/IP Addresses) who committed these actions
	private Player player;
	
	private String currentName;

	// # of times this player was kicked or banned during this game
	private int kickBans = 0;
/**
 * Player constructor comment.
 */
public GamePlayer() 
{
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 2:04:54 PM)
 * @param newAlias java.lang.String
 */
public void addAlias( String newAlias ) 
{
	player.addAlias( newAlias );
	setCurrentName( newAlias );
}
/**
 * Increment the count of how many times this player defused the bomb
 * Creation date: (8/28/00 2:56:09 PM)
 */
public void addBombDefuse() 
{
	bombDefuses++;
}
/**
 * Increment the count of how many times this player planted the bomb
 * Creation date: (8/28/00 2:56:09 PM)
 */
public void addBombPlant() 
{
	bombPlants++;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:56:09 PM)
 */
public void addDeath() 
{
	deaths++;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:56:09 PM)
 */
public void addHostageKill() 
{
	killedHostages++;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:56:09 PM)
 */
public void addHostageRescue() 
{
	rescuedHostages++;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:56:09 PM)
 */
public void addHostageTouch() 
{
	touchedHostages++;
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 2:04:54 PM)
 * @param newIP java.lang.String
 */
public void addIP( String newIP ) 
{
	player.addIP( newIP );
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:56:09 PM)
 */
public void addKickban() 
{
	kickBans++;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:56:09 PM)
 */
public void addKill() 
{
	kills++;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:49:45 PM)
 */
public void addReconnect() 
{
	reconnects++;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:49:45 PM)
 */
public void addTk() 
{
	tks++;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:56:09 PM)
 */
public void addVipKill() 
{
	vipKills++;
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 2:07:23 PM)
 * @return java.util.List
 */
public List getAliases() 
{
	return player.getAliases();
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:05:21 PM)
 * @return int
 */
public int getBombDefuses() {
	return bombDefuses;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:05:21 PM)
 * @return int
 */
public int getBombPlants() {
	return bombPlants;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 10:27:04 AM)
 * @return java.lang.String
 */
public java.lang.String getCurrentName() {
	return currentName;
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 11:40:06 AM)
 * @return int
 */
public int getCurrentTeam() {
	return currentTeam;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:48:46 PM)
 * @return int
 */
public int getDeaths() {
	return deaths;
}
/**
 * Insert the method's description here.
 * Creation date: (8/29/00 8:21:12 AM)
 * @return int
 */
public int getEscapes() {
	return escapes;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:10:21 PM)
 * @return int
 */
public int getGameId() {
	return gameId;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:48:46 PM)
 * @return java.util.ArrayList
 */
public java.util.ArrayList getIpAddresses() 
{
	return player.getIpAddresses();
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 7:52:54 AM)
 * @return int
 */
public int getKickBans() {
	return kickBans;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:05:21 PM)
 * @return int
 */
public int getKilledHostages() {
	return killedHostages;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:48:46 PM)
 * @return int
 */
public int getKills() {
	return kills;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:19:03 PM)
 * @return org.halfcat.halflife.cstrike.Player
 */
public Player getPlayer() {
	return player;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:48:46 PM)
 * @return int
 */
public int getReconnects() {
	return reconnects;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:05:21 PM)
 * @return int
 */
public int getRescuedHostages() {
	return rescuedHostages;
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 2:11:38 PM)
 * @return int
 */
public int getServerId() {
	return serverId;
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 11:40:34 AM)
 * @return int
 */
public int getTeamChangeCount() 
{
	return teamChangeCount;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 3:59:03 PM)
 * @return int
 */
public int getTks() {
	return tks;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:05:21 PM)
 * @return int
 */
public int getTouchedHostages() {
	return touchedHostages;
}
/**
 * Insert the method's description here.
 * Creation date: (8/29/00 8:21:12 AM)
 * @return int
 */
public int getVipKills() {
	return vipKills;
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 11:39:13 AM)
 * @return long
 */
public long getWonID() 
{
	return wonID;
}
/**
 * Reset all of the per-game statistics for this GamePlayer:
 * Kills, Deaths, Rejoins, etc.
 * Creation date: (8/28/00 2:30:01 PM)
 */
public void reset() 
{
	kills  = 0;
	deaths = 0;
	teamChangeCount = 0;
	reconnects = UNDEFINED;
	
	// for persistence
	m_objectId = 0;
	m_objectState = org.halfcat.persistence.ObjectState.NEW;	
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:05:21 PM)
 * @param newBombDefuses int
 */
public void setBombDefuses(int newBombDefuses) {
	bombDefuses = newBombDefuses;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:05:21 PM)
 * @param newBombPlants int
 */
public void setBombPlants(int newBombPlants) {
	bombPlants = newBombPlants;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 10:27:04 AM)
 * @param newCurrentName java.lang.String
 */
public void setCurrentName(java.lang.String newCurrentName) {
	currentName = newCurrentName;
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 11:40:06 AM)
 * @param newCurrentTeam int
 */
public void setCurrentTeam( int newCurrentTeam ) 
{
	currentTeam = newCurrentTeam;
	teamChangeCount++;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:48:46 PM)
 * @param newDeaths int
 */
public void setDeaths( int newDeaths ) 
{
	deaths = newDeaths;
}
/**
 * Insert the method's description here.
 * Creation date: (8/29/00 8:21:12 AM)
 * @param newEscapes int
 */
public void setEscapes(int newEscapes) {
	escapes = newEscapes;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:10:21 PM)
 * @param newGameId int
 */
public void setGameId(int newGameId) {
	gameId = newGameId;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 7:52:54 AM)
 * @param newKickBans int
 */
public void setKickBans(int newKickBans) {
	kickBans = newKickBans;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:05:21 PM)
 * @param newKilledHostages int
 */
public void setKilledHostages(int newKilledHostages) {
	killedHostages = newKilledHostages;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:48:46 PM)
 * @param newKills int
 */
public void setKills( int newKills ) 
{
	kills = newKills;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:19:03 PM)
 * @param newPlayer org.halfcat.halflife.cstrike.Player
 */
public void setPlayer(Player newPlayer) 
{
	player = newPlayer;
	wonID = player.getWonID();
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:48:46 PM)
 * @param newReconnects int
 */
public void setReconnects(int newReconnects) 
{
	reconnects = newReconnects;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:05:21 PM)
 * @param newRescuedHostages int
 */
public void setRescuedHostages(int newRescuedHostages) 
{
	rescuedHostages = newRescuedHostages;
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 2:11:38 PM)
 * @param newServerId int
 */
public void setServerId(int newServerId) 
{
	serverId = newServerId;
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 11:40:34 AM)
 * @param newTeamChangeCount int
 */
public void setTeamChangeCount(int newTeamChangeCount) 
{
	teamChangeCount = newTeamChangeCount;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 3:59:03 PM)
 * @param newTks int
 */
public void setTks(int newTks) 
{
	tks = newTks;
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 4:05:21 PM)
 * @param newTouchedHostages int
 */
public void setTouchedHostages(int newTouchedHostages) 
{
	touchedHostages = newTouchedHostages;
}
/**
 * Insert the method's description here.
 * Creation date: (8/29/00 8:21:12 AM)
 * @param newVipKills int
 */
public void setVipKills(int newVipKills) {
	vipKills = newVipKills;
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 11:39:13 AM)
 * @param newWonID long
 */
public void setWonID(long newWonID) 
{
	wonID = newWonID;
}
}
