package org.halfcat.halflife.cstrike;

import java.sql.*;
import java.io.*;
import java.util.*;
import java.text.*;
import org.halfcat.persistence.*;

/**
 * Insert the type's description here.
 * Creation date: (8/13/00 3:50:51 PM)
 * @author: Administrator
 */
public class GameSource 
{
	public static boolean processing;
/**
 * GameSource constructor comment.
 */
public GameSource() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (8/28/00 2:44:41 PM)
 * @return java.util.List
 */
public static Game getGame( int gameId ) 
{
	List l = DataManager.fetchLimited( Game.class, "oid", new Integer( gameId ) );
	if ( l != null && l.size() > 0 )
	{
		Game g = (Game)l.get( 0 );
		List players = DataManager.fetchLimited( GamePlayer.class, "gameId", new Integer( gameId ) );
		if ( players != null )
			g.setPlayers( players );

		return g;
	}
	return null;
}
/**
 * Insert the method's description here.
 * Creation date: (9/2/00 12:59:23 PM)
 * @param args java.lang.String[]
 */
public static void main(String[] args) 
{
	String dbHost = "192.168.1.7";
	String dbName = "halfcat3";
	int dbPort = 5432;
	String dbLogin = "howellc";
	String dbPasswd = "howellc";
	try
	{
		String dbURL = DataSource.createDbUrl( dbHost, dbName, dbPort, null );
		DataSource.connectToDB( dbURL, dbLogin, dbPasswd );
	}
	catch( Exception e )
	{
		e.printStackTrace();
		System.exit( 0 );
	}
	
	Game g = GameSource.getGame( 136371 );
	System.out.println( "Got back " + g );
}
/**
 * Save all of the information about a game to the DB
 * TO-DO(?):  use addbatch() (once implemented)
 * Creation date: (8/13/00 3:51:09 PM)
 * @param g bing.cstrike.Game
 */
public static boolean save( Game g ) 
{
	// do something to save the game
	DateFormat df = DateFormat.getDateTimeInstance();


	if ( ! processing )
	{
		System.out.println( "NOT saving " + df.format( g.getStartTime() ) + "--Processing disabled" );
		return false;
	}

	//
	// Save Kicks/Bans
	//
	List kickBans = g.getKickBans();
	if ( kickBans != null )
	{
		Iterator i = kickBans.iterator();
		while ( i.hasNext() )
			try
			{
				DataManager.save( (KickBan)i.next() );
			}
			catch( SQLException sqe )
			{
				System.out.println( "Failed to save Kickban: " + sqe.getMessage() );
			}
	}

	//
	// check if we want to save the game or not
	//
	if ( g.getGamePlayers().size() == 0 )
	{
		System.out.println( "NOT saving " + df.format( g.getStartTime() ) + " to " +
		df.format( g.getEndTime() ) + " on map " + g.getMapName() + "--no players" );
		return false;
	}

	//
	// Make sure we have valid start & end times
	//	
	if ( g.getStartTime() == null )
		g.setStartTime( new java.util.Date() );
	System.out.println( "Saving game: " + df.format( g.getStartTime() ) + " to " +
		df.format( g.getEndTime() ) + " on map " + g.getMapName() );

	//
	// Save the Game to DB
	//
	int gid = 0;
	try
	{
		DataManager.save( g );
		gid = g.getObjectId();
	}
	catch( SQLException sqe )
	{
		System.out.println( "Failed to save game!" );
		sqe.printStackTrace();
	}

	//
	// Save the GamePlayer's to DB
	//
	GamePlayer gp = null;
  ArrayList al = new ArrayList();
  al.addAll( g.getGamePlayers( GamePlayer.COUNTERTERRORIST ).values() );
  al.addAll( g.getGamePlayers( GamePlayer.TERRORIST ).values() );
  al.addAll( g.getGamePlayers( GamePlayer.UNDEFINED ).values() );
  Iterator i = al.iterator();
  
	while ( i.hasNext() )
	{
		try
		{
			gp = (GamePlayer)i.next();

			// skip players who didn't *do* anything in a game
			if ( gp.getKills() == 0 && gp.getDeaths() == 0 && gp.getTks() == 0 && gp.getBombDefuses() == 0 &&
						gp.getBombPlants() == 0 && gp.getTouchedHostages() == 0 && gp.getRescuedHostages() == 0 && gp.getEscapes() == 0 && gp.getKilledHostages() == 0 )
				continue;
				
			gp.setGameId( gid );
			DataManager.save( gp );
		}
		catch( SQLException sqe2 )
		{
			System.out.println( "Failed to save  gamePlayer " + gp.getCurrentName() );
			sqe2.printStackTrace();
		}
	}
/*		
	try
	{
		org.halfcat.persistence.DataManager.save( g );
	}
	catch( Exception e )
	{
		e.printStackTrace();
	}
*/
	return true;	
}
}
