package org.halfcat.halflife.cstrike;

import java.sql.*;
import java.util.*;
import org.halfcat.persistence.*;
/**
 * Insert the type's description here.
 * Creation date: (8/13/00 2:00:27 PM)
 * @author: Administrator
 */
public class PlayerSource 
{
	private static Hashtable WONsource = new Hashtable();
	private static Hashtable ServerIdSource = new Hashtable();
	private static Hashtable nameSource = new Hashtable();

	public static boolean processing = true;
	
/**
 * PlayerSource constructor comment.
 */
public PlayerSource() 
{
	super();
}
/**
 * if database writes are enabled, save the new alias to the DB
 * Creation date: (9/9/00 7:21:16 AM)
 * @return org.halfcat.halflife.cstrike.PlayerAlias
 * @param wonId long
 * @param newAlias java.lang.String
 */
protected static void addAlias( long wonId, String newAlias ) 
{
	if ( processing )	
	{	
		System.out.println( "adding alias: " + newAlias );

		try
		{
			PlayerAlias pa = new PlayerAlias( wonId, newAlias );
			DataManager.save( pa );
		}
		catch( SQLException sqe )
		{
			System.out.println( "Failed to save alias!" );
			sqe.printStackTrace();
		}
	}		
}
/**
 * if database writes are enabled, save the new alias to the DB
 * Creation date: (9/9/00 7:21:16 AM)
 * @return org.halfcat.halflife.cstrike.PlayerAlias
 * @param wonId long
 * @param newAlias java.lang.String
 */
protected static void addIP( long wonId, String newIP ) 
{
	if ( processing )	
	{	
		System.out.println( "adding address: " + newIP );

		try
		{
			PlayerIPAddress pa = new PlayerIPAddress( wonId, newIP );
			DataManager.save( pa );
		}
		catch( SQLException sqe )
		{
			System.out.println( "Failed to save address!" );
			sqe.printStackTrace();
		}
	}		
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 2:09:11 PM)
 * @param name java.lang.String
 * @param wonID long
 * @param serverId int
 * @param sourceIP java.lang.String
 */
public synchronized static void addPlayer( String name, long wonID, int serverId, String sourceIP ) 
{
	Player p = getPlayer( wonID );

	if ( p == null )
	{
		p = new Player();
		p.setWonID( wonID );
	}
	
	// do these in any case
	p.addAlias( name );
	p.addIP( sourceIP );

	addPlayer( p );
	
	
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 2:13:39 PM)
 * @param p bing.cstrike.Player
 */
public synchronized static void addPlayer( GamePlayer p ) 
{
	WONsource.put( new Long( p.getWonID() ), p );
	ServerIdSource.put( new Integer( p.getServerId() ), p );
	nameSource.put( p.getCurrentName(), p );
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 2:13:39 PM)
 * @param p bing.cstrike.Player
 */
public synchronized static void addPlayer( Player p ) 
{
	WONsource.put( new Long( p.getWonID() ), p );

	try
	{
		if ( processing )	
			org.halfcat.persistence.DataManager.save( p );
	}
	catch( Exception e )
	{
		e.printStackTrace();
	}
}
/**
 * Get a reference to a GamePlayer based on their serverId
 * Creation date: (8/13/00 2:01:18 PM)
 * @param wonID long
 */
public static GamePlayer getPlayer( int serverId )
{
	Long l = new Long( serverId );
	if ( ServerIdSource.containsKey( l ) )
		return (GamePlayer)ServerIdSource.get( l );
	else
		return null;
}
/**
 * Insert the method's description here.
 * Creation date: (8/13/00 2:01:18 PM)
 * @param wonID long
 */
public static Player getPlayer( long wonID )
{
	if ( wonID == -1 )
		return null;
		
	Long l = new Long( wonID );
	
	if ( WONsource.containsKey( l ) )
		return (Player)WONsource.get( l );
	else
	{
		try
		{
			List pl = DataManager.fetchLimited( Player.class, "wonid", l );
			if ( pl.size() > 0 )
			{
				Player p = (Player)pl.get( 0 );

				p.setAliases( DataManager.fetchLimited( PlayerAlias.class, "wonid", l ) );
				p.setIpAddresses( DataManager.fetchLimited( PlayerIPAddress.class, "wonid", l ) );
		
				return p;
			}
		}
		catch( Exception e )
		{
			System.out.println( "wonID " + wonID + " not found in DB." );
			e.printStackTrace();
		}	
		return null;
	}
}
}
