package org.halfcat.halflife.cstrike.maps;

import org.halfcat.halflife.cstrike.*;
import java.sql.*;
import java.util.*;
import org.halfcat.persistence.*;

public class FragMap
	extends AbstractObjectMap
{
	private static String   TABLENAME = "Frags";
	private static String[] FIELDS = { "isFriendlyFire", "WONkiller", "WONvictim", "weapon", "victimTeam", "fragTime" };
public FragMap() { super(); }
public String[] getFields() { return FIELDS; }
public String getTableName() { return TABLENAME; }
public Persistable populate( Persistable p, ResultSet rs )
	throws SQLException
{	if ( p == null )
		p = new Frag();
	Frag f = (Frag)p;
	f.setObjectId( rs.getInt( 1 ) );
	f.setIsFriendlyFire( rs.getBoolean( 2 ) );
	f.setWONkiller( rs.getLong( 3 ) );
	f.setWONvictim( rs.getLong( 4 ) );
	f.setWeapon( rs.getString( 5 ) );
	f.setVictimTeam( rs.getInt( 6 ) );
	f.setFragTime( rs.getDate( 7 ) );
	return f;
}
public int prepareInsert( Persistable p, PreparedStatement ps )
	throws SQLException
{
	Frag f = (Frag)p;
	ps.setBoolean( 1, f.isFriendlyFire() );
	ps.setLong( 2, f.getWONkiller() );
	ps.setLong( 3, f.getWONvictim() );
	ps.setString( 4, f.getWeapon() );
	ps.setInt( 5, f.getVictimTeam() );
	ps.setTimestamp( 6, new java.sql.Timestamp( f.getFragTime().getTime() ) );
	return 6;
}
}
