package org.halfcat.halflife.cstrike.maps;

import org.halfcat.halflife.cstrike.*;
import java.sql.*;
import java.util.*;
import org.halfcat.persistence.*;

public class GameMap
	extends AbstractObjectMap
{
	private static String   TABLENAME = "Games";
	private static String[] FIELDS = { "startTime", "endTime", "mapName", "friendlyFireOn", "c4Timer", "ctWins", "terrWins", "draws", "serverId" };
public GameMap() { super(); }
public String[] getFields() { return FIELDS; }
public String getTableName() { return TABLENAME; }
public Persistable populate( Persistable p, ResultSet rs )
	throws SQLException
{	if ( p == null )
		p = new Game();
	Game f = (Game)p;
	f.setObjectId( rs.getInt( 1 ) );
	f.setStartTime( rs.getTimestamp( 2 ) );
	f.setEndTime( rs.getTimestamp( 3 ) );
	f.setMapName( rs.getString( 4 ) );
	f.setFriendlyFireOn( rs.getBoolean( 5 ) );
	f.setC4Timer( rs.getInt( 6 ) );
	f.setCtWins( rs.getInt( 7 ) );
	f.setTerrWins( rs.getInt( 8 ) );
	f.setDraws( rs.getInt( 9 ) );
	f.setServerId( rs.getInt( 10 ) );
	return f;
}
public int prepareInsert( Persistable p, PreparedStatement ps )
	throws SQLException
{
	Game f = (Game)p;
	ps.setTimestamp( 1, new java.sql.Timestamp( f.getStartTime().getTime() ) );
	ps.setTimestamp( 2, new java.sql.Timestamp( f.getEndTime().getTime() ) );
	ps.setString( 3, f.getMapName() );
	ps.setBoolean( 4, f.isFriendlyFireOn() );
	ps.setInt( 5, f.getC4Timer() );
	ps.setInt( 6, f.getCtWins() );
	ps.setInt( 7, f.getTerrWins() );
	ps.setInt( 8, f.getDraws() );
	ps.setInt( 9, f.getServerId() );
	return 9;
}
}
