package org.halfcat.halflife.cstrike.maps;

import org.halfcat.halflife.cstrike.*;
import java.sql.*;
import java.util.*;
import org.halfcat.persistence.*;

public class GamePlayerMap
	extends AbstractObjectMap
{
	private static String   TABLENAME = "GamePlayers";
	private static String[] FIELDS = { "wonID", "currentTeam", "kills", "deaths", "gameId", 
		"tks", "touchedHostages", "rescuedHostages", "killedHostages", "bombPlants", 
		"bombDefuses", "vipKills", "escapes", "reconnects", "teamChangeCount", "serverId", 
		"currentName", "kickbans" };
public GamePlayerMap() { super(); }
public String[] getFields() { return FIELDS; }
public String getTableName() { return TABLENAME; }
public Persistable populate( Persistable p, ResultSet rs )
	throws SQLException
{	if ( p == null )
		p = new GamePlayer();
	GamePlayer f = (GamePlayer)p;
	f.setObjectId( rs.getInt( 1 ) );
	f.setWonID( rs.getLong( 2 ) );
	f.setCurrentTeam( rs.getInt( 3 ) );
	f.setKills( rs.getInt( 4 ) );
	f.setDeaths( rs.getInt( 5 ) );
	f.setGameId( rs.getInt( 6 ) );
	f.setTks( rs.getInt( 7 ) );
	f.setTouchedHostages( rs.getInt( 8 ) );
	f.setRescuedHostages( rs.getInt( 9 ) );
	f.setKilledHostages( rs.getInt( 10 ) );
	f.setBombPlants( rs.getInt( 11 ) );
	f.setBombDefuses( rs.getInt( 12 ) );
	f.setVipKills( rs.getInt( 13 ) );
	f.setEscapes( rs.getInt( 14 ) );
	f.setReconnects( rs.getInt( 15 ) );
	f.setTeamChangeCount( rs.getInt( 16 ) );
	f.setServerId( rs.getInt( 17 ) );
	f.setCurrentName( rs.getString( 18 ) );
	f.setKickBans( rs.getInt( 19 ) );
	return f;
}
public int prepareInsert( Persistable p, PreparedStatement ps )
	throws SQLException
{
	GamePlayer f = (GamePlayer)p;
	ps.setLong( 1, f.getWonID() );
	ps.setInt( 2, f.getCurrentTeam() );
	ps.setInt( 3, f.getKills() );
	ps.setInt( 4, f.getDeaths() );
	ps.setInt( 5, f.getGameId() );
	ps.setInt( 6, f.getTks() );
	ps.setInt( 7, f.getTouchedHostages() );
	ps.setInt( 8, f.getRescuedHostages() );
	ps.setInt( 9, f.getKilledHostages() );
	ps.setInt( 10, f.getBombPlants() );
	ps.setInt( 11, f.getBombDefuses() );
	ps.setInt( 12, f.getVipKills() );
	ps.setInt( 13, f.getEscapes() );
	ps.setInt( 14, f.getReconnects() );
	ps.setInt( 15, f.getTeamChangeCount() );
	ps.setInt( 16, f.getServerId() );
	ps.setString( 17, f.getCurrentName() );
	ps.setInt( 18, f.getKickBans() );
	return 18;
}
}
