package org.halfcat.halflife.cstrike.maps;

import org.halfcat.halflife.cstrike.*;
import java.sql.*;
import java.util.*;
import org.halfcat.persistence.*;

public class KickBanMap
	extends AbstractObjectMap
{
	private static String   TABLENAME = "kickBans";
	private static String[] FIELDS = { "wonID", "banIP", "action", "banTime", "server", "dateTime" };
public KickBanMap() { super(); }
public String[] getFields() { return FIELDS; }
public String getTableName() { return TABLENAME; }
public Persistable populate( Persistable p, ResultSet rs )
	throws SQLException
{	if ( p == null )
		p = new KickBan();
	KickBan f = (KickBan)p;
	f.setObjectId( rs.getInt( 1 ) );
	f.setWonID( rs.getLong( 2 ) );
	f.setBanIP( rs.getString( 3 ) );
	f.setAction( rs.getInt( 4 ) );
	f.setBanTime( rs.getInt( 5 ) );
	f.setServer( rs.getInt( 6 ) );
	f.setDateTime( rs.getDate( 7 ) );
	return f;
}
public int prepareInsert( Persistable p, PreparedStatement ps )
	throws SQLException
{
	KickBan f = (KickBan)p;
	ps.setLong( 1, f.getWonID() );
	ps.setString( 2, f.getBanIP() );
	ps.setInt( 3, f.getAction() );
	ps.setInt( 4, f.getBanTime() );
	ps.setInt( 5, f.getServer() );
	ps.setTimestamp( 6, new java.sql.Timestamp( f.getDateTime().getTime() ) );
	return 6;
}
}
