package org.halfcat.halflife.info;

import java.sql.*;
import java.util.*;
import org.halfcat.halflife.*;
import org.halfcat.halflife.cstrike.*;
import org.halfcat.persistence.*;
/**
 * Insert the type's description here.
 * Creation date: (9/9/00 7:02:43 AM)
 * @author: Administrator
 */
public class PlayerInfo 
{
/**
 * PlayerInfo constructor comment.
 */
private PlayerInfo() {
	super();
}
/**
 * Return the list of GamePlayer's for each game this player played in
 * Creation date: (9/9/00 8:17:29 AM)
 * @return java.util.List
 * @param wonId long
 */
public List getGames( List games ) 
{
	List l = DataManager.fetchIn( Game.class, "oid", games );

	// sort them
	GamePlayerComparator gcp = new GamePlayerComparator();
	Collections.sort( l, gcp );
	return l;
	
//	return DataManager.fetchLimited( GamePlayer.class, "wonid", new Long( wonId ) );
}
/**
 * Return a list of KickBan's for this wonId
 * Creation date: (9/9/00 8:12:18 AM)
 * @return java.util.List
 * @param wonId long
 */
public static List getKickbans( long wonId ) 
{
	return DataManager.fetchLimited( KickBan.class, "wonId", new Long( wonId ) );
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 7:03:42 AM)
 * @param name java.lang.String
 * @param exact boolean
 */
public static List getPlayersByName( String name, boolean exact ) 
{
	String comparator = "=";
	
	if ( ! exact )
	{
		name = "'%" + name + "%'";
		comparator = "LIKE";
	}
	else
		name = "'" + name + "'";

	return DataManager.fetchLimitedSorted( PlayerAlias.class, "alias", name, "LIKE", "alias", false );	
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 7:12:10 AM)
 * @param args java.lang.String[]
 */
public static void main(String[] args) 
{
	String dbHost = "192.168.1.7";
	String dbName = "halfcat4";
	int    dbPort = 5432;
	String dbLogin = "howellc";
	String dbPasswd = "password";
	java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat( "dd MMM yy HH:mm zzz" );
	//
	// Connect to the DB
	//	
	try
	{
		String dbURL = DataSource.createDbUrl( dbHost, dbName, dbPort, null );
		DataSource.connectToDB( dbURL, dbLogin, dbPasswd );
	}
	catch( Exception e )
	{
		e.printStackTrace();
		System.exit( 0 );
	}
	System.out.println( "10 most recent games:" );
	int x = 1;
	RecentGames rg = new RecentGames();
//	Iterator i = rg.getGames( 157184 ).iterator();
	Iterator i = rg.getGames( "63.89.102.206", 27017 ).iterator();
	while ( i.hasNext() )
	{
		Game g = (Game)i.next();
		System.out.println( "" + x++ + ". " + sdf.format( g.getStartTime() ) );
	}
/*	
	List games = DataManager.fetchLimitedSorted( Game.class, "serverId", new Integer( 157184 ), "=", "startTime", false );
	Iterator i = games.iterator();
	while ( i.hasNext() )
	{
		Game g = (Game)i.next();
		System.out.println( sdf.format( g.getStartTime() ) );
	}
*/	
/*
	System.out.println( "Inexact Match: " );
	List players = getPlayersByName( "Bing", false );
	Iterator i = players.iterator();
	while ( i.hasNext() )
	{
		PlayerAlias pa = (PlayerAlias)i.next();
		System.out.println( pa.getWonID() + ":\t" + pa.getAlias() );
	}
	
	System.out.println( "\nExact Match: " );
	players = getPlayersByName( "Bing", true );
	i = players.iterator();
	while ( i.hasNext() )
	{
		PlayerAlias pa = (PlayerAlias)i.next();
		System.out.println( pa.getWonID() + ":\t" + pa.getAlias() );
	}
	PlayerSummary ps = new PlayerSummary( (long)22312959 );
	System.out.println( "PlayerSummary for " + ps.getWonId() + " " + ps.getGames().size()
		+ " games" );
*/
	
	DataSource.closeConnection();
}
}
