package org.halfcat.halflife.info;

import java.sql.*;
import java.util.*;
import org.halfcat.halflife.cstrike.*;
import org.halfcat.persistence.*;
/**
 * Insert the type's description here.
 * Creation date: (9/9/00 8:59:11 AM)
 * @author: Administrator
 */
public class PlayerSummary 
{
	long wonId = -1;

	private boolean initialized = false;
	boolean validPlayer = false;

	Player p = null;
	// key:  Integer(gameId), value:  Game
	Hashtable games = new Hashtable();

	// key:  Integer( gameId ), value:  GamePlayer
	Hashtable gamePlayers = new Hashtable();

	// sum of each attribute for this player
	int kills = 0;
	int deaths = 0;
	int hostageTouches = 0;
	int hostageRescues = 0;
	//int hk = 0;
	int tks = 0;
	int bombPlants = 0;
	int bombDefuses = 0;
	int vipKills = 0;
	int reconnects = 0;
	int kickbans = 0;
	int teamChanges = 0;
/**
 * PlayerSummary constructor comment.
 */
private PlayerSummary() 
{
	super();
}
/**
 * PlayerSummary constructor comment.
 */
public PlayerSummary( long wonId ) 
{
	super();
	this.wonId = wonId;
	initialize();
}
/**
 * Return a comma-delimited String of all the ip addresses this player has connected from
 * Creation date: (9/9/00 9:22:41 AM)
 * @return java.lang.String
 */
public String getAddresses() 
{
	StringBuffer sb = new StringBuffer();
  Iterator i = p.getIpAddresses().iterator();
  while ( i.hasNext() )
  {
		sb.append( i.next() );
   if ( i.hasNext() )
			sb.append( ", " );
   
  }
  return sb.toString();
}
/**
 *  * Return a comma-delimited String of all the aliases this player has used
 * Creation date: (9/9/00 9:22:41 AM)
 * @return java.lang.String
 */
public String getAliases() 
{
	StringBuffer sb = new StringBuffer();
  Iterator i = p.getAliases().iterator();
  while ( i.hasNext() )
  {
		sb.append( i.next() );
   if ( i.hasNext() )
			sb.append( ", " );
   
  }
  return sb.toString();
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:31:33 AM)
 * @return int
 */
public int getBombDefuses() {
	return bombDefuses;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:31:33 AM)
 * @return int
 */
public int getBombPlants() {
	return bombPlants;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:31:33 AM)
 * @return int
 */
public int getDeaths() {
	return deaths;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:16:31 AM)
 * @return org.halfcat.halflife.cstrike.Game
 * @param gameId int
 */
public Game getGame( int gameId ) 
{
	Integer i = new Integer( gameId );
	if ( games.containsKey( i ) )
		return (Game)games.get( i );
	else
		return null;
}
/**
 * Return this player's GamePlayer for the specified game
 * Creation date: (9/9/00 9:16:31 AM)
 * @return org.halfcat.halflife.cstrike.Game
 * @param gameId int
 */
public GamePlayer getGamePlayer( int gameId ) 
{
	Integer i = new Integer( gameId );
	if ( gamePlayers.containsKey( i ) )
		return (GamePlayer)gamePlayers.get( i );
	else
		return null;
}
/**
 * List of all games this player has played in
 * Creation date: (9/9/00 9:15:41 AM)
 * @return java.util.List
 */
public List getGames() 
{
	List l = new ArrayList( games.values() );
	Collections.sort( l, new GameComparator() );
	return l;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:31:33 AM)
 * @return int
 */
public int getHostageRescues() {
	return hostageRescues;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:31:33 AM)
 * @return int
 */
public int getHostageTouches() {
	return hostageTouches;
}
/**
 * Return the number of times this player has been kicked or banned
 * Creation date: (9/9/00 9:35:18 AM)
 * @return int
 */
public int getKickbans() 
{
	return kickbans;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:31:33 AM)
 * @return int
 */
public int getKills() {
	return kills;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:21:06 AM)
 * @return org.halfcat.halflife.cstrike.Player
 */
public Player getPlayer() 
{
	return p;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:31:33 AM)
 * @return int
 */
public int getReconnects() {
	return reconnects;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:35:18 AM)
 * @return int
 */
public int getTeamChanges() {
	return teamChanges;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:31:33 AM)
 * @return int
 */
public int getTks() {
	return tks;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:31:33 AM)
 * @return int
 */
public int getVipKills() {
	return vipKills;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:14:13 AM)
 * @return long
 */
public long getWonId() {
	return wonId;
}
/**
 * Return true if the player has multiple aliases in the DB
 * Creation date: (9/9/00 9:24:27 AM)
 * @return boolean
 */
public boolean hasMultipleAliases() 
{
	return ( p.getAliases() != null && p.getAliases().size() > 1 );
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:00:36 AM)
 */
private synchronized void initialize() 
{
	if ( initialized )
	{
		System.out.println( "already initialized" );
		return;
	}
	
	try
	{
		List gameIds = new ArrayList();
		Long w = new Long( wonId );

		// get the player info for this player
		p = PlayerSource.getPlayer( wonId );
		if ( p != null )
			validPlayer = true;
		else
			return;

		// Load all the GamePlayer's for this player
		List l = DataManager.fetchLimited( GamePlayer.class, "wonid", w, "=" );

		Iterator i = l.iterator();
		while ( i.hasNext() )
		{
			GamePlayer gp = (GamePlayer)i.next();
			Integer gid = new Integer( gp.getGameId() );
			
			gamePlayers.put( gid, gp );
			gameIds.add( gid );

			// someday, this can all happen in the DB, but for now it's done programmatically
			// here
			kills          += gp.getKills();
			deaths         += gp.getDeaths();
			hostageTouches += gp.getTouchedHostages();
			hostageRescues += gp.getRescuedHostages();
			tks            += gp.getTks();
			bombPlants     += gp.getBombPlants();
			bombDefuses    += gp.getBombDefuses();
			vipKills       += gp.getVipKills();
			reconnects     += gp.getReconnects();
			kickbans       += gp.getKickBans();
			teamChanges    += gp.getTeamChangeCount();			
		}

		// get the list of Game objects for this player
		System.out.println( "GameId's for " + wonId + ": " + gameIds.size() );
		List ll = DataManager.fetchIn( Game.class, "oid", gameIds );

//		Collections.sort( ll, new GameComparator() );

		i = ll.iterator();
		while ( i.hasNext() )
		{
			Game g = (Game)i.next();
			games.put( new Integer( g.getObjectId() ), g );
		}
		
		initialized = true;
	}
	catch( Exception e )
	{
		initialized = false;
		System.out.println( "Failed to initialize PlayerSummary for " + wonId );
		e.printStackTrace();
	}
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:48:36 AM)
 * @return boolean
 */
public boolean isValidPlayer() {
	return validPlayer;
}
/**
 * Insert the method's description here.
 * Creation date: (9/9/00 9:48:36 AM)
 * @param newValidPlayer boolean
 */
void setValidPlayer(boolean newValidPlayer) {
	validPlayer = newValidPlayer;
}
}
