package org.halfcat.halflife.maps;

import org.halfcat.halflife.*;
import java.sql.*;
import java.util.*;
import org.halfcat.persistence.*;

public class ServerRecordMap
	extends AbstractObjectMap
{
	private static String   TABLENAME = "ServerRecords";
	private static String[] FIELDS = { "address", "port", "serverId" };
public ServerRecordMap() { super(); }
public String[] getFields() { return FIELDS; }
public String getTableName() { return TABLENAME; }
public Persistable populate( Persistable p, ResultSet rs )
	throws SQLException
{	if ( p == null )
		p = new ServerRecord();
	ServerRecord f = (ServerRecord)p;
	f.setObjectId( rs.getInt( 1 ) );
	f.setAddress( rs.getString( 2 ) );
	f.setPort( rs.getInt( 3 ) );
	f.setServerId( rs.getInt( 4 ) );
	return f;
}
public int prepareInsert( Persistable p, PreparedStatement ps )
	throws SQLException
{
	ServerRecord f = (ServerRecord)p;
	ps.setString( 1, f.getAddress() );
	ps.setInt( 2, f.getPort() );
	ps.setInt( 3, f.getServerId() );
	return 3;
}
}
