package org.halfcat.halflife.maps;

import org.halfcat.halflife.*;
import java.sql.*;
import java.util.*;
import org.halfcat.persistence.*;

public class ServerToWonMap
	extends AbstractObjectMap
{
	private static String   TABLENAME = "serverToWon";
	private static String[] FIELDS = { "wonID", "serverID", "server" };
public ServerToWonMap() { super(); }
public String[] getFields() { return FIELDS; }
public String getTableName() { return TABLENAME; }
public Persistable populate( Persistable p, ResultSet rs )
	throws SQLException
{	if ( p == null )
		p = new ServerToWon();
	ServerToWon f = (ServerToWon)p;
	f.setObjectId( rs.getInt( 1 ) );
	f.setWonID( rs.getLong( 2 ) );
	f.setServerID( rs.getInt( 3 ) );
	f.setServer( rs.getInt( 4 ) );
	return f;
}
public int prepareInsert( Persistable p, PreparedStatement ps )
	throws SQLException
{
	ServerToWon f = (ServerToWon)p;
	ps.setLong( 1, f.getWonID() );
	ps.setInt( 2, f.getServerID() );
	ps.setInt( 3, f.getServer() );
	return 3;
}
}
